dojo.provide("websheet.model.CellModel");
dojo.require("dojox.collections.Stack");
dojo.require("websheet.model.StyleCode");

dojo.declare("websheet.model.CellModel",null,{
	_showValue:"",				//if it is a formula,this will be its calculative value.Or _rawValue.
	
	_rawValue: "",				//user input.
	
	_calculateValue: "",		//used to show the result of formula
	
	sheetName: null,
	
	_referencedList:null,		//cells list this cell referent.
	
	_relativeList:null,			
	
	_dependencedList:null,		//cells list which is dependent on this cell. 
	
	_tokenList:null,
	
	_parent:null,				//cell parent is row
	_document:null,
	
	_column:null,				//cell in column object
	
	repeatednum:null,			//compress cell
	
	styleID: null,				// reserved, for future style support use.
	
	styleCode: null,
	
	commentsId: null,
	
	calculateStatus:false,
	
	isBroken:false,				//decide whether the cell is broken,maybe it is recycle cell
	
	isError:false,				//if the cell has formula and formula has error,then mark it
	
	isFormula:false,			//decide whether it is a formula cell
	
	isIgnoreRecursive:false,	//decide whether the cell ignore recursive.	e.g:if the cell address is A4,its content
								//is =Row(A4),then return a correct value 4.
	isArrayFormular:false,		//decide whether the cell is a array formular,like "{=Row(A4)}".
	
	isNumber:false,
	
	isString:false,
	hasUnsupportedFormula: false, // indicate whether there's unsupported formula in this cell
	unsupportedFormula: null, // unsupported formula type
	colspan: null, //span columns
	rowspan: null, //span rows
	text_align:null,  //default set of text_align
	
	constructor: function(value,column,rowObj,showValue,repeatednum,commentsId, colspan,rowspan,calculatedvalue,text_align) {
		
		if(undefined != value)
			this._rawValue = value;
		if(undefined != showValue)
			this._showValue = showValue;
		if(undefined != calculatedvalue)
			this._calculateValue = calculatedvalue;
		this._parent = rowObj;
		this._document = rowObj._document;
		this._column = column;
		if(undefined != repeatednum)
			this.repeatednum = repeatednum;
		if(undefined != commentsId&&commentsId.length!=0){
			this.commentsId = commentsId;
			this.getParent().getParent().getParent().setCommentsCellIndex(this.getParent().getParent()._name,commentsId,this.getParent().index,this._column.index);	
		}
		if(undefined != colspan)
			this.colspan = colspan;
		if(undefined != rowspan)
			this.rowspan = rowspan;
		if(undefined != text_align)
			this.text_align = text_align;
	},
	
	/*
	 * construct cell json for event 
	 * null: if this cell is empty
	 */
	toEventJson: function()
	{
		var cell = {};
	    var isExist = false;
	    if(undefined != this._showValue && null != this._showValue && this._showValue.length != 0)
	    {
	        cell.showvalue = this._showValue;
	        isExist = true;
	    }
	    if(undefined != this._rawValue && null != this._rawValue && this._rawValue.length != 0)
	    {
	        cell.value = this._rawValue;
	        isExist = true;
	    }
	    if(this.repeatednum != null)
	    {
	        cell.repeatednum = this.repeatednum;
	        isExist = true;
	    }
	    if(this.styleCode != null)
	    {
			var strStyleCode = JSON.stringify(this.styleCode);
			var newStyleCodeJson = JSON.parse(strStyleCode);
			cell.style = newStyleCodeJson;
			isExist = true;
	    }
	    if(this.commentsId != null){
	    	cell.commentsId = this.commentsId;
	    	isExist = true;
	    }
	    if(isExist){
	    	return cell;
	    }else{
	    	return null;
	    }    
	},

	_parse: function(notSend){
		this.clearReference();
		this.calculateStatus = true;
		if((this._rawValue.indexOf("=") == 0 || this._rawValue.indexOf("{=") == 0) && this._rawValue != "="){
			this.isFormula = true;
			var parseResult = websheet.parse.parseHelper._parse(this);
			if(parseResult.isError){
				this.isError = true;
				this.hasUnsupportedFormula = (parseResult.errorType == websheet.parse.parseHelper.UNSUPPORTEDFORMULA);
			}
			if (this.hasUnsupportedFormula)
			{
				this.unsupportedFormula = parseResult.result;
				// do NOT change showvalue here.
			}
			else
			{
				this.setShowValue(parseResult.result,notSend);
			}
		}else{
			this.isFormula = false;
			this.setShowValue(this.getRawValue(),notSend);
		}
	},
	
	_parse2: function(notSend){
		this.clearReference();
		this.calculateStatus = true;
		if((this._rawValue.indexOf("=") == 0 || this._rawValue.indexOf("{=") == 0) && this._rawValue != "="){
			this.isFormula = true;
			this.setShowValue(this._calculateValue,notSend);
		}else{
			this.isFormula = false;
			this.setShowValue(this.getRawValue(),notSend);
		}
	},
	
	
	/*
	 * added by ruisuy@cn.ibm.com 2010/9/20
	 * if the cell has unsupported formula in it, return the unsupported formula name
	 * elese return null;
	 */
	getFormulaError: function(){
		if ((this.isError)&&(this.hasUnsupportedFormula))
		{
			return this.unsupportedFormula;
		}
		else
			return null;
	},	
	
	clearShowValue: function ( notSend ){
		var oldShowValue = this._showValue;
		this._showValue = "";
		//TODO
		if(!notSend && !this.getDocument().status){
		/*	
			var sheetIndex=this._parent.getParent().index;
			var rowIndex=this._parent.index;
			var columnIndex=string2Number(this._column.index);
			var firstArgument=sheetIndex+","+rowIndex+","+columnIndex+",showvalue";
			nativeObj.update(firstArgument,"");
			if(this.isFormula)
			{
				firstArgument=sheetIndex+","+rowIndex+","+columnIndex+",calculatedvalue";
				nativeObj.update(firstArgument,"");
			}
		*/
			var attr = {"showvalue":""};
			websheet.event.eventFactory.addEventCell(this.makeReference(),attr);
		}
	},
	
	clearReference:function(){
		var referCells = this.getReferencedList();
		if(referCells.length != 0){
			var cellRef = null;
			dojo.forEach(referCells,function(item,index){
				dojo.every(item.getCalcuteValue().getCells(),function(cell){
					if(cell && cell.getCellVieType() != null){
						cell.getCellVieType().deleteDependence(this);
						cell.getCellVieType().getColumn().deleteDependence(this);
						cell.getCellVieType().getParent().deleteDependence(this);
					}
				},this);
			},this);
		}
		this.isError = false;
		this.isBroken = false;
		this.isFormula = false;
		this.isIgnoreRecursive = false;
		this.isArrayFormular = false;
		this._referencedList = null;
		this._relativeList = null;
		delete this._referencedList;
		delete this._relativeList;
	},
	
	deleteDependence:function(cell){
		var dependenceList = this.getDependencedList(); 
		if(dependenceList.length != 0){
			dojo.every(dependenceList,function(item,index){
				if(item == cell){
					dependenceList.splice(index,1);
					return;
				}
			},this);
		}	
	},
	
	adjustCellPos: function(relativeRow, relativeColumn, orginalRow, orginalColumn) {
		if (!relativeRow && !relativeColumn) return;
		this.row += relativeRow;
		this.col += relativeColumn;
		setCellRef (this.row, this.col);

		for (var t in tokens) {
			if (isRowRef(t) && relRow && t >= orginalRow) {
				t += relativeRow;
			} else if (isColRef(t) && relCol && t >= orginalColumn) {
				t += relativeColumn;
			}
		}
		setCellValueWithTokens (tokens);
	},
	
	getSheetName:function(){
		return this.getParent().getParent().getSheetName();
	},
	
	setShowValue:function(showValue,notSend){
		var oldShowValue = this._showValue;
		this._showValue = showValue;
		if(!notSend && !this.getDocument().status){
			//TODO
		/*
			var sheetIndex=this._parent.getParent().index;
			var rowIndex=this._parent.index;
			var columnIndex=string2Number(this._column.index);
			var firstArgument=sheetIndex+","+rowIndex+","+columnIndex+",showvalue";
			nativeObj.update(firstArgument,showValue+"");
			if(this.isFormula)
			{
				firstArgument=sheetIndex+","+rowIndex+","+columnIndex+",calculatedvalue";
				nativeObj.update(firstArgument,showValue+"");
			}
		*/	
			//var attr = {"showvalue":showValue};
			//websheet.event.eventFactory.addEventCell(this.makeReference(),attr);
		}
	},
	/**
	 * returns 1-based textual reference
	 *
	 * @param {String|Number} inField
	 * @param {Number} inRowIndex !!zero-based!!
	 */
	makeReference: function() {
		return this.getParent().getParent().getSheetName() + "." + this.getCol() + this.getRow();
	},
	
	getShowValue:function(){
		return this._showValue;
	},
	
	setParent:function(parent){
		this._parent = parent;
	},
	
	getParent:function(){
		return this._parent;
	},
	
	setColumn:function(column){
		this._column = column;
	},
	
	getColumn:function(){
		return this._column;
	},
	
	setRawValue:function(rawValue,notSend){
		this._rawValue = rawValue;

		if(!notSend && !this.getDocument().status){
			//TODO
		/*
			var sheetIndex=this._parent.getParent().index;
			var rowIndex=this._parent.index;
			var columnIndex=string2Number(this._column.index);
			var firstArgument=sheetIndex+","+rowIndex+","+columnIndex+",value";
			nativeObj.update(firstArgument,rawValue+"");
		*/	
			//send event
			//var attr = {"value":rawValue};
			//websheet.event.eventFactory.addEventCell(this.makeReference(),attr);
		}
		return this._showValueCalculation(notSend);
	},
	/* set cell comments id*/
	createCellComments:function( commentsId){
		this.commentsId = commentsId;
	},
	/* delete cell comments by id*/
	delCellComments:function(){
		this.commentsId = undefined;
	},
	getRawValue:function(){
		return this._rawValue;
	},
	
	getCellRef: function() {
		return this.getSheetName() + "." + this.getColumn().getIndex() + this.getParent().getIndex(); 
	},

	setCellTokens: function(tokens) {
		this.tokens = tokens;
	},

	setCellValueWithTokens: function(tokens) {
		 
	},

	isRowRef: function(ref) {
		return false;
	},

	isColRef: function(ref) {
		return false;
	},
	
	getRow:function(){
		return this.getParent().getIndex();
	},
	
	getCol:function(){
		return this.getColumn().getIndex();
	},
	
	setTokenList:function(tokenList){
		var list = tokenList;
		if(!(tokenList instanceof websheet.parse.tokenList)){
			list = new websheet.parse.tokenList();
			list.push(tokenList);
		}
		this._tokenList = list;
	},
	
	getTokenList:function(){
		if(!this._tokenList){
			this._tokenList = new websheet.parse.tokenList();
			this._tokenList.cell = this;
		}
		return this._tokenList;
	},

	newTokenList:function(){
		var tokenList = new websheet.parse.tokenList();
		tokenList.cell = this;
		return tokenList;
	},
	
	getReferencedList:function(){
		if(!this._referencedList){
			this._referencedList = new Array();
		}
		return this._referencedList;	
	},
	
	setReferencedList:function(referencedList){
		this._referencedList = referencedList;	
	},
	
	getDocument:function(){
		return this.getParent().getParent().getParent();
	},
	
	getStyle:function(){
		return this.styleCode;
	},
	
	/*getStyleID: function(){
		return this.styleID;
	},*/
	
	setStyle:function(newStyleCode){
		if (this.styleCode)
			delete this.styleCode;
		if (newStyleCode!=null){
			this.styleCode = new websheet.model.StyleCode("FROMOBJ", newStyleCode);
			this.getParent().addStyleCell(this);
		}else{ this.styleCode = null;this.getParent().deleteStyleCell(this);}
	},
	
	isEqual: function(otherCell)
	{
		if(null == otherCell)
		{
			return false;
		}
		this._showValue = (this._showValue == null || this._showValue == undefined )? "": this._showValue;
		this._rawValue = (this._rawValue == null || this._rawValue == undefined )? "": this._rawValue;
		var cRepeatednum = (this.repeatednum == null || this.repeatednum == undefined)? 0 : parseInt(this.repeatednum);
		var cStyleCode = ( this.styleCode == undefined ) ? null: this.styleCode;
		
		otherCell._showValue = (otherCell._showValue == null || otherCell._showValue == undefined )? "": otherCell._showValue;
		otherCell._rawValue = (otherCell._rawValue == null || otherCell._rawValue == undefined )? "": otherCell._rawValue;
		var oRepeatednum = (otherCell.repeatednum == null || otherCell.repeatednum == undefined)? 0 : parseInt(otherCell.repeatednum);
		var oStyleCode = ( otherCell.styleCode == undefined ) ? null: otherCell.styleCode;
		
		if(this._showValue != otherCell._showValue
		|| this._rawValue != otherCell._rawValue
		|| cRepeatednum != oRepeatednum)
		{
			return false;
		}
		
		if((null == cStyleCode && null != oStyleCode)
		  ||(null == oStyleCode && null != cStyleCode))
		{
			return false;
		}
		if((null == cStyleCode && null == oStyleCode)
		 || cStyleCode.compareWithme(oStyleCode)  == true)
	    {
		 	return true;
	    }
	    return false;
	},
	
	is2CellCanMerge: function(pCell, lCell)
	{
		if(null == pCell || null == lCell)
		{
			return false;
		}
		if(pCell._showValue != "" || pCell._rawValue != ""
		 ||lCell._showValue != "" || lCell._rawValue != "")
		 {
		 	return false;
		 }
		 
		var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
		var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
		var pColIndex = char2Num(pCell.getCol());
		var pRepeatNum = (pCell.repeatednum == null || pCell.repeatednum == undefined)? 0: parseInt(pCell.repeatednum);
		var lColIndex = char2Num(lCell.getCol());
		if(pColIndex + pRepeatNum + 1 != lColIndex)
		{
			return false;
		}
		
		if(null == pCell.styleCode || undefined == pCell.styleCode
		|| null == lCell.styleCode || undefined == lCell.styleCode)
		{
			return false;
		}
		return pCell.styleCode.compareWithme(lCell.styleCode);
	},
	/*zhaojp add */
	setDefaultStyle:function(newStyleCode){ 
		websheet.RepeatHelper.splitRow(this.getParent().getParent(),this.getParent(),this.getCol());
		if (this.styleCode)
			delete this.styleCode;
		if (newStyleCode!=null){
			this.styleCode = new websheet.model.StyleCode("FROMOBJ", newStyleCode);
			this.getParent().addStyleCell(this);
		}
		else
		{ this.styleCode = null;this.getParent().deleteStyleCell(this);}
	},
	
	changeStyle: function(styleChange,splitCell) {
		if (styleChange == null)
		{	
			return;
		}
		if(splitCell){
			websheet.RepeatHelper.splitCell(this.getParent(),this);
		}else{
			websheet.RepeatHelper.splitRow(this.getParent().getParent(),this.getParent(),this.getCol());
		}
		if (this.styleCode == null)
		{
			this.styleCode = new websheet.model.StyleCode("FROMOBJ", styleChange);
			this.styleCode.changeStyle(styleChange);
			this.getParent().addStyleCell(this);
		}
		else
		{
			this.styleCode.changeStyle(styleChange);
		}
		if (this.styleCode.checkDefault())
		{
			delete this.styleCode;
			this.styleCode = null;
			this.getParent().deleteStyleCell(this);
		}
		websheet.RepeatHelper.mergeCell(this.getParent(),this.getCol());
		websheet.RepeatHelper.mergeRow(this.getParent().getParent(),this.getParent());
	},
		
	/* when put reference cell,it will add current cell to the dependence list of the referent cell */
	pushReferenceList: function(cellToken){
		this.getReferencedList().push(cellToken);
		var cell = null;
		var parsedRef = websheet.Helper.parseRef(cellToken.getToken());
		var referSheet = this.getParent().getParent();
		if(parsedRef.sheet && parsedRef.sheet != this.getSheetName()){
			referSheet = this.getDocument().getSheet(parsedRef.sheet);
		}
		//set dependent cell list
		if(cellToken.getTokenType() == websheet.parse.tokenType.CELLREF_TOKEN){
			 var doc = this.getDocument();
			 cell = doc.getCell(parsedRef.sheet||this.getSheetName(),parsedRef.row,parsedRef.column,true);
			 if(cell == null || cell == undefined){
				 cell = doc.getSheet(parsedRef.sheet||this.getSheetName()).createCell(parsedRef.row,parsedRef.column,"");
			 }
			 if(!this.isIgnoreRecursive){
				 if(cell == this){this.isBroken = true;throw "###Cyclic Reference###";}
			 }
			 cell.addDependenceList(this);
			 referSheet.addDependenceList(this);
			 doc.getSheet(parsedRef.sheet||this.getSheetName()).getRow(cell.getRow(),true).addDependenceList(this);
			 doc.getSheet(parsedRef.sheet||this.getSheetName()).getColumn(cell.getCol(),true).addDependenceList(this);
		}else if(cellToken.getTokenType() == websheet.parse.tokenType.RANGEREF_TOKEN){
			 var doc = this.getDocument(); 
			 var r = parsedRef.row;
			 var sl = websheet.ColumnHelper.translateFromColCharacters(parsedRef.column);
			 var el = websheet.ColumnHelper.translateFromColCharacters(parsedRef.endColumn);
			 var l = sl;
			 var charL = l;
			 while(r <= parsedRef.endRow){
				 l = sl;
				 while(l <= el){
					 charL = websheet.ColumnHelper.translateFromColNum(l);
					 cell = doc.getCell(parsedRef.sheet||this.getSheetName(),r,charL,true);
					 if(cell == null || cell == undefined){
						 cell = doc.getSheet(parsedRef.sheet||this.getSheetName()).createCell(r,charL,"");
					 }
					 if(!this.isIgnoreRecursive){
						 if(cell == this){this.isBroken = true;throw "###Cyclic Reference###";}
					 }
					 cell.addDependenceList(this);
					 doc.getSheet(parsedRef.sheet||this.getSheetName()).addDependenceList(this);
					 doc.getSheet(parsedRef.sheet||this.getSheetName()).getRow(r,true).addDependenceList(this);
					 doc.getSheet(parsedRef.sheet||this.getSheetName()).getColumn(charL,true).addDependenceList(this);
					 l += 1;
				 }
				 r +=  1;
			 }
		}
	},
	
	addDependenceList:function(cell){
		var isLoad = false;
		dojo.forEach(this.getDependencedList(),function(item){
			if(item == cell){
				isLoad = true;
				return;
			}
		});
		if(!isLoad){
			this.getDependencedList().push(cell);
		}
	},
	getDependencedList:function(){
		if(!this._dependencedList){
			this._dependencedList = new Array();
		}
		return this._dependencedList;	
	},
	
	setDependencedList:function(dependencedList){
		this._dependencedList = dependencedList;	
	},
	
	getRelativeList:function(){
		if(!this._relativeList){
			this._relativeList = new Array();
		}
		return this._relativeList;
	},
	
	setRelativeList:function(relativeList){
		this._relativeList = relativeList;	
	},
	
	_showValueCalculation: function (notSend) {
//		this._parse(notSend);
		this._parse2(notSend);
//		this.getDocument().clearRowUpdate();
		this.getDocument().clearMemory();
		this.getDocument().clearRecycle();
		this.dependenceAutoUpdate();
		if(this.getDocument().isRecycle){
			dojo.forEach(this.getDocument().getRecycle().toArray(),function(cell){
				cell.setShowValue("###Cyclic Reference###");
			},this);
		}
		this.getDocument().isRecycle = null;
		this.getDocument().clearMemory();
		this.getDocument().clearRecycle();
		return this.getDocument().getRowUpdate();
	},
	
	/* call the dependence cell to update */
	dependenceAutoUpdate: function(isError){
		//escape the cyclic reference
		var dependences = this.getDependencedList();
		this.getDocument().addRecycle(this);
		if(!isError){
			if(this.getDocument().getMemory().contains(this)){
				this.getDocument().isRecycle = true;
				return;
			}else{
				this.getDocument().addMemory(this);
			}
		}
		dojo.forEach(dependences,function(cell){
			if(!cell.isBroken){
				cell.referenceAutoUpdate(this.getCellRef(),0,isError);
				if(cell.getSheetName() == this.getSheetName()){
					this.getDocument().addRowUpdate(cell.getRow());
				}else{
					var ref = cell.getSheetName() + "." + cell.getRow();
					this.getDocument().addRowUpdate(ref);
				}
			}
		},this);
		if(!isError){
			this.getDocument().getMemory().pop();
		}
	},

	/* according the update cell to recalculate its token tree by itself. */
	/* status 1:must update calculative*/
	referenceAutoUpdate: function (ref,status,isError) {
		var doc = this.getDocument();
		try{
			if(isError){
				this.setShowValue("###Cyclic Reference###");
			}else{
				dojo.forEach(this.getReferencedList(),function(cellRef){
					var oriRef = websheet.Helper.parseRef(ref);
					var curStartRef = websheet.Helper.parseRef(cellRef.getCalcuteValue().getStartAddress());
					var curEndRef = websheet.Helper.parseRef(cellRef.getCalcuteValue().getEndAddress());
					var update = false;
					if(status && status== 1){update = true;}
					if(!update){
						if(oriRef.sheet){
							if(oriRef.sheet == (curStartRef.sheet||this.getSheetName())){
								if(curEndRef){
									if(oriRef.row <= curEndRef.row && oriRef.row >= curStartRef.row && oriRef.column <= curEndRef.column && oriRef.column >= curStartRef.column){
										update = true;
									}
								}else{
									if(oriRef.row == curStartRef.row  && oriRef.column == curStartRef.column){
										update = true;
									}
								}
							}
						}else {
							if(curEndRef){
								if(oriRef.row <= curEndRef.row && oriRef.row >= curStartRef.row && oriRef.column <= curEndRef.column && oriRef.column >= curStartRef.column){
									update = true;
								}
							}else{
								if(oriRef.row == curStartRef.row  && oriRef.column == curStartRef.column){
									update = true;
								}
							}
						}
					}
					//search for the update reference cell,then recalculate the formula by the part in tree.
					//we don't supports that determine whether the cell range has specific cell.
					if(update){
						var recalculateValue;
						this.setShowValue(websheet.parse.parseHelper.recalculateByPart(cellRef,recalculateValue,doc));
					}
	
				},this);
			}
		}catch(e){
			var error = (e.message || e.toString() || "Error");
			if(error.indexOf("###") != -1){
				this.setShowValue(error);
			}else{
				this.setShowValue('###' + error + '###');
			}
//			this.setRawValue(e.message || e.toString() || "Error",true);
			this.isError = true;
		}finally{
			try{
				if(!this.isIgnoreRecursive){
					this.dependenceAutoUpdate(isError);
				}
			}catch(e){
				this.setShowValue('###Cyclic Reference###');
			}
		}
	},
	
	reGenerateFormula:function(deleteType,notSend){
		var result = this.getTokenList().serialize2String(1,deleteType);
		if(result.isArrayFormular){
			this.setRawValue("{=" + result.rawValue + "}",notSend);
		}else{
			this.setRawValue("=" + result.rawValue,notSend);
		}
		if(result.isError){
			this.setShowValue('####REF!####',notSend);
		}
		this.getDocument().addRowUpdate(this.getRow());
	},
	
	copy2Next:function(cellModel){
		if(!cellModel){return;}
		cellModel.setStyle(new websheet.model.StyleCode("FROMOBJ",this.getStyle()));
		cellModel.repeatednum = this.repeatednum;
		
	}
});
