/********************************************************/
/* created by Rui SuYing, ruisuy@cn.ibm.com				*/
/*  2010/6/28											*/
/* for range object in a spreadsheet document			*/
/********************************************************/
//ROAModel is about cell info,relative or absolute.
dojo.provide("websheet.model.ROAModel");

dojo.declare("websheet.model.ROAModel",null,{
	cell:null,				//base position object.
	sheetName:null,				//cell in sheet
	row:null,				//cell in row
	col:null,				//cell in column
	type:0,					//cell type,relative or absolute
	hasSheetRef:false,
	
	//construtor
	constructor:function(cell,sheetName,row,col,type,hasSheetRef){
		this.cell = cell;
		this.sheetName = sheetName;
		this.row = row;
		this.col = col;
		this.type = type;
		this.hasSheetRef = hasSheetRef;
	},
	//get the cell vie the cell type
	getCellVieType:function(){
		if(this.cell == null){return null;}
		var doc = this.cell.getDocument();
		var cellSheetName = this.cell.getSheetName();
		var cellRowIndex = this.cell.getParent().getIndex();
		var cellColIndex = this.cell .getColumn().getIndex();
		var cell;
		switch(this.type){
			case websheet.model.ROAType.BOTHRELATIVE:
				 cell = doc.getCell(cellSheetName,cellRowIndex,cellColIndex,true);
				 this.cell = cell;
				 break;
			case websheet.model.ROAType.ROWRELATIVE:
				 cell = doc.getCell(cellSheetName,cellRowIndex,this.col,true);
				 this.cell = cell;
				 this.col = this.col;
			case websheet.model.ROAType.COLUMNRELATIVE:
				 cell = doc.getCell(cellSheetName,this.row,cellColIndex,true);
				 this.cell = cell;
				 this.row = cellRowIndex;
			case websheet.model.ROAType.BOTHABSOLUTE:
				 cell = doc.getCell(cellSheetName,this.row,this.col,true);
				 this.cell = cell;
				 this.row = cellRowIndex;
				 this.col = cellColIndex;
			default:
				break;
		}
		return cell;
	},
	
	getCell:function(){
		return this.cell;
	}
});
websheet.model.ROAType = {
	BOTHRELATIVE	:0,		//like A1
	ROWRELATIVE 	:1,		//like $A1
	COLUMNRELATIVE	:2,		//like A$1
	BOTHABSOLUTE	:3		//like $A$1
};