dojo.provide("websheet.RepeatHelper");

websheet.RepeatHelper = {
		sheetName:null,
		cellRepeateNum:null,
		rowRepeateNum:null,
		cellStyle:null,
		row:null,
		column:null,
		preRowIndex:null,
		preColIndex:null,
		update:false,
		
		clear:function(){
			delete this.cellRepeateNum;
			delete this.cellStyle;
			delete this.rowRepeateNum;
			delete this.row;
			delete this.column;
			delete this.preRowIndex;
			delete this.preColIndex;
			this.update = false;
		},
		
		query4CellStyle:function(sheetModel,rowModel,rowIndex,colIndex){
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			if(this.cellRepeateNum == undefined || this.cellRepeateNum == 0){
				delete this.cellStyle;
				delete this.cellRepeateNum;
			}
			//row repeate number substract 1
			if(this.rowRepeateNum != undefined && colIndex == "A"){
				this.rowRepeateNum -= 1;
			}
			var cell = rowModel.getStyleCell(colIndex);
			if(cell){
				this.cellStyle = cell.getStyle();
				if(cell.repeatednum != undefined){
					this.cellRepeateNum = cell.repeatednum;
				}
				this.preColIndex = colIndex;
				return cell.getStyle();
			}
			var reload = false;
			if((this.preRowIndex && this.preRowIndex != rowIndex) || (sheetModel && sheetModel.getSheetName() != this.sheetName)){
				reload = true;
			}
			if(!reload && this.preColIndex != undefined){
				var delta = char2Num(colIndex) - char2Num(this.preColIndex);
				if(delta > 1){
					this.cellRepeateNum -= (delta - 1);
				}
				if(this.cellRepeateNum <= 0){
					delete this.cellRepeateNum;
				}
			}
			//in case whether the cell repeate number exist
			//if exist,then get the current cell style
			//else to fetch style in row or column
			if(!this.cellRepeateNum || this.cellRepeateNum == 0 || reload){
				//in case whether the row repeate number exist
				//if exist,then get the cell style in row
				//else to fetch current row style
				var row;
				var styleCell;
				if(this.rowRepeateNum == undefined || this.rowRepeateNum < 0){
					row = sheetModel.getRepeatedRow(rowIndex);
					if(row){
						this.row = row;
						this.rowRepeateNum = row.repeatednum;
					}
				}else{
					row = this.row;
				}
				if(row){
					styleCell = row.getRepeatedCell(colIndex);
					if(styleCell){
						this.cellStyle = styleCell.getStyle();
						var colDelta = char2Num(colIndex) - char2Num(styleCell.getCol());
						if(colDelta > 0){
							this.cellRepeateNum = styleCell.repeatednum - colDelta;
						}
					}
				}
				if(!styleCell){
					//in case whether the column repeate number exist
					//if exist,then get the cell style in column
					//else to fetch current column style
					var column = sheetModel.getRepeatedColumn(colIndex);
					if(column){
						this.column = column;
						this.cellStyle = column.getStyle();
						var colDelta = char2Num(column.getIndex()) - char2Num(colIndex);
						if(colDelta > 0 && column.repeatednum - colDelta >= 0){
							this.cellRepeateNum = column.repeatednum - colDelta;
						}else{
							delete this.cellRepeateNum;
						}
					}else{
						delete this.cellRepeateNum;
						delete this.cellStyle;
						delete this.column;
					}
				}
			}else{
				this.cellRepeateNum -= 1;
			}
			this.preRowIndex = rowIndex;
			this.preColIndex = colIndex;
			return this.cellStyle;
		},
	   
		mergeCell:function(rowModel,strColIndex)
		{
			if(null==rowModel || undefined==rowModel || null==strColIndex || undefined==strColIndex )
			{
				return;
			}
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			var colIndex = char2Num(strColIndex);
//			var strColIndex = num2Char(colIndex);
			var curCell = rowModel.getRepeatedCell(strColIndex);
			if(null == curCell || undefined == curCell)
			{
				return ;
			}
			var pCell = null;
			var lCell = null;
			var pColIndex = colIndex - 1;
			if(pColIndex > 0)
			{
				var strPColIndex = num2Char(pColIndex);
				pCell = rowModel.getRepeatedCell(strPColIndex);
				pCell = ( undefined == pCell)? null : pCell;
			}
			var lColIndex = colIndex + 1;
			var strLColIndex = num2Char(lColIndex);
			lCell = rowModel.getRepeatedCell(strLColIndex);
			lCell = ( undefined == lCell)? null : lCell;
			if(null != lCell)
			{
				if(curCell.is2CellCanMerge(curCell,lCell))
				{
					var lRepeatNum = (lCell.repeatednum == null || lCell.repeatednum == undefined)? 0: parseInt(lCell.repeatednum);
					var cRepeatNum = (curCell.repeatednum == null || curCell.repeatednum == undefined)? 0: parseInt(curCell.repeatednum);
					curCell.repeatednum = cRepeatNum + lRepeatNum + 1;
					rowModel.deleteStyleCell(lCell);
					delete rowModel.cells[strLColIndex];
				}
			}
			if(null != pCell)
			{
				if(pCell.is2CellCanMerge(pCell,curCell))
				{
					var pRepeatNum = (pCell.repeatednum == null || pCell.repeatednum == undefined)? 0: parseInt(pCell.repeatednum);
					var cRepeatNum = (curCell.repeatednum == null || curCell.repeatednum == undefined)? 0: parseInt(curCell.repeatednum);
					pCell.repeatednum = pRepeatNum + cRepeatNum + 1;
					rowModel.deleteStyleCell(curCell);
					delete rowModel.cells[strColIndex];
				}
			}
		},
		
		mergeRow: function(sheetModel,rowModel)
		{
			if(sheetModel == null || sheetModel == undefined || rowModel == null || rowModel == undefined){return;}
			var curRowIndex = rowModel.getIndex();
			var curRow = sheetModel.getRepeatedRow(curRowIndex);
			if(null == curRow || undefined == curRow)
			{
				return ;
			}
			var pRow = null;
			var lRow = null;
			var pRowIndex = curRowIndex - 1;
			var lRowIndex = curRowIndex + 1;
			if(pRowIndex > 0)
			{
				pRow = sheetModel.getRepeatedRow(pRowIndex);
				pRow = (pRow == undefined)? null : pRow;
			}
			lRow = sheetModel.getRepeatedRow(lRowIndex);
			lRow = (lRow == undefined)? null : lRow;
			if(null != lRow)
			{
				if(curRow.is2RowCanMerge(curRow,lRow))
				{
					var lRepeatNum = (lRow.repeatednum == null || lRow.repeatednum == undefined)? 0: parseInt(lRow.repeatednum);
					var cRepeatNum = (curRow.repeatednum == null || curRow.repeatednum == undefined)? 0: parseInt(curRow.repeatednum);
					curRow.repeatednum = cRepeatNum + lRepeatNum + 1;
					sheetModel.deleteStyleRow(lRow);
//					delete sheetModel.rows[lRowIndex];
					sheetModel.getParent().addRowUpdate(lRowIndex);
				}
			}
			if(null != pRow)
			{
				if(pRow.is2RowCanMerge(pRow,curRow))
				{
					var pRepeatNum = (pRow.repeatednum == null || pRow.repeatednum == undefined)? 0: parseInt(pRow.repeatednum);
					var cRepeatNum = (curRow.repeatednum == null || curRow.repeatednum == undefined)? 0: parseInt(curRow.repeatednum);
					pRow.repeatednum = cRepeatNum + pRepeatNum + 1;
					sheetModel.deleteStyleRow(curRow);
//					delete sheetModel.rows[curRowIndex];
					sheetModel.getParent().addRowUpdate(curRowIndex);
				}
			}
		},
		
		/*
		 * divide the column has repeateNum into two part
		 * if the colIndex is the startIndex of column, do not need split
		 */
		divideColumn: function(sheetModel,colIndex)
		{
			if(sheetModel == null || sheetModel == undefined || colIndex == null || colIndex == undefined){return;}
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			var iColIndex = char2Num(colIndex);
			var repeateColumn = sheetModel.getRepeatedColumn(colIndex);
			if(repeateColumn)
			{
				var startColIndex = repeateColumn.getIndex();
				if(startColIndex != colIndex)
				{
					var iStartColIndex = char2Num(startColIndex);
					var repeateNum = (repeateColumn.repeatednum == null || repeateColumn.repeatednum == undefined)? 0:repeateColumn.repeatednum;
				
					var nextColumn = sheetModel.getColumn(iColIndex,true);
					repeateColumn.copy2Next(nextColumn);
					nextColumn.repeatednum = iStartColIndex + repeateNum - iColIndex;
					sheetModel.addStyleColumn(nextColumn);
					repeateColumn.repeatednum = iColIndex - iStartColIndex -1;
				}
			}
		},
		
		/*
		 * divide the cell has repeateNum into two part
		 * if the colIndex is the startIndex of cell, do not need split
		 */
		divideCell: function(rowModel, colIndex)
		{
			if(rowModel == null || rowModel == undefined ){return;}
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			var strColIndex = colIndex;
			var iColIndex = char2Num(strColIndex);
			var repeateCell = rowModel.getRepeatedCell(strColIndex);
			if(repeateCell)
			{
				var repeateCellColIndex = repeateCell.getCol();
				if(repeateCellColIndex != strColIndex)
				{
					var iRepeateCellColIndex = char2Num(repeateCellColIndex);
					var repeateNum = (repeateCell.repeatednum == null || repeateCell.repeatednum == undefined)? 0:repeateCell.repeatednum;
					
				    var nextCell = rowModel.getCell(strColIndex,true);
					repeateCell.copy2Next(nextCell);
					nextCell.repeatednum = iRepeateCellColIndex + repeateNum - iColIndex;
					rowModel.addStyleCell(nextCell);
					repeateCell.repeatednum =  iColIndex - iRepeateCellColIndex-1;
				}
			}
		},
		
		mergeColumn: function(sheetModel,columnModel)
		{
			if(sheetModel == null || sheetModel == undefined || columnModel == null || columnModel == undefined){return;}
			var curColIndex = columnModel.getIndex();
			var curCol = sheetModel.getRepeatedColumn(curColIndex);
			if(null == curCol || undefined == curCol)
			{
				return ;
			}
			var pCol = null;
			var lCol = null;
			var pColIndex = curColIndex - 1;
			var lColIndex = curColIndex + 1;
			if(pColIndex > 0)
			{
				pCol = sheetModel.getRepeatedColumn(pColIndex);
				pCol = (pCol == undefined)? null : pCol;
			}
			lCol = sheetModel.getRepeatedRow(lColIndex);
			lCol = (lCol == undefined)? null : lCol;
			if(null != lCol)
			{
				if(curCol.is2ColCanMerge(curCol,lCol))
				{
					var lRepeatNum = (lCol.repeatednum == null || lCol.repeatednum == undefined)? 0: parseInt(lCol.repeatednum);
					var cRepeatNum = (curCol.repeatednum == null || curCol.repeatednum == undefined)? 0: parseInt(curCol.repeatednum);
					curCol.repeatednum = cRepeatNum + lRepeatNum + 1;
					sheetModel.deleteStyleColumn(lCol);
				}
			}
			if(null != pCol)
			{
				if(pCol.is2ColCanMerge(pCol,curCol))
				{
					var pRepeatNum = (pCol.repeatednum == null || pCol.repeatednum == undefined)? 0: parseInt(pCol.repeatednum);
					var cRepeatNum = (curCol.repeatednum == null || curCol.repeatednum == undefined)? 0: parseInt(curCol.repeatednum);
					pCol.repeatednum = cRepeatNum + pRepeatNum + 1;
					sheetModel.deleteStyleColumn(curCol);
				}
			}
		},
		splitCell:function(rowModel,cellModel){
			if(rowModel == null || rowModel == undefined || cellModel == null || cellModel == undefined){return;}
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			var curCellChar = cellModel.getCol();
			var curCellIndex = char2Num(curCellChar);
			var repeateCell = rowModel.getRepeatedCell(curCellChar);
			
			if(repeateCell){
				if(null == repeateCell.repeatednum || undefined == repeateCell.repeatednum || 0 == parseInt(repeateCell.repeatednum))
				{
					return;
				}
				var repeatNum = repeateCell.repeatednum;
				var nextCell;
				if(repeateCell.getCol() == cellModel.getCol() && repeateCell.getRow() == cellModel.getRow()){
					if(repeatNum != undefined && repeatNum != 0){
						//if current row is the repeate row,then copy the repeate number to next row
						nextCell = rowModel.getCell(num2Char(curCellIndex + 1),true);
						cellModel.copy2Next(nextCell);
						delete cellModel.repeatednum;
						
						if(repeatNum == 1){
							delete nextCell.repeatednum;
						}else{
							nextCell.repeatednum -= 1;
						}
						rowModel.addStyleCell(nextCell);
					}
					rowModel.addStyleCell(cellModel);
				}else{
					var repeateIndex = char2Num(repeateCell.getCol());
					var lastIndex = repeateIndex + repeatNum;
					//if current row is at the end of the repeate range of the repeate row
					if(lastIndex ==  curCellIndex){
						if(repeatNum == 1){
							delete repeateCell.repeatednum;
						}else{
							repeateCell.repeatednum -= 1;
						}
					}else{
					//if current row is in the middle of the repeate range of the repeate row
						var preDelta = curCellIndex - repeateIndex - 1;
						var nextDelta = lastIndex - curCellIndex - 1;
						nextCell = rowModel.getCell(num2Char(curCellIndex + 1),true);
						if(preDelta == 0){
							delete repeateCell.repeatednum;
						}else{
							repeateCell.repeatednum = preDelta;
						}
						repeateCell.copy2Next(nextCell);
						rowModel.addStyleCell(nextCell);
						if(nextDelta != 0){
							nextCell.repeatednum = nextDelta;
						}
					}
					cellModel.setStyle(repeateCell.getStyle());
					repeateCell.copy2Next(cellModel);
					rowModel.addStyleCell(cellModel);
					delete cellModel.repeatednum;
				}
			}else{
				var sheet = rowModel.getParent();
				var column = sheet.getRepeatedColumn(cellModel.getCol());
				if(column){
					cellModel.setStyle(column.getStyle());
					rowModel.addStyleCell(cellModel);
				}
			}
		},
		
		splitRow:function(sheetModel,rowModel,colIndex){
			if(sheetModel == null || sheetModel == undefined || rowModel == null || rowModel == undefined){return;}
			var curRowIndex = rowModel.getIndex();
			var repeateRow = sheetModel.getRepeatedRow(curRowIndex);

			if(repeateRow){
				//DO NOT NEED split
				if(null == repeateRow.repeatednum || undefined == repeateRow.repeatednum || 0 == parseInt(repeateRow.repeatednum))
				{
					if(colIndex){
						this.splitCell(rowModel, rowModel.getCell(colIndex,true));
					}
					return;
				}
				var repeatNum = repeateRow.repeatednum;
				var nextRow = sheetModel.getRow(curRowIndex + 1,true);
				if(repeateRow == rowModel){
					if(repeatNum != undefined && repeatNum != 0){
						//if current row is the repeate row,then copy the repeate number to next row
						delete nextRow.styleCells;
						rowModel.copy2Next(nextRow);
						delete rowModel.repeatednum;
						if(repeatNum == 1){
							delete nextRow.repeatednum;
						}else{
							nextRow.repeatednum -= 1;
						}
						sheetModel.addStyleRow(nextRow);
					}
				}else{
					var repeateIndex = repeateRow.getIndex();
					var lastIndex = repeateIndex + repeatNum;
					//if current row is at the end of the repeate range of the repeate row
					if(lastIndex ==  curRowIndex){
						if(repeatNum == 1){
							delete repeateRow.repeatednum;
						}else{
							repeateRow.repeatednum -= 1;
						}
					}else{
					//if current row is in the middle of the repeate range of the repeate row
						var preDelta = curRowIndex - repeateIndex - 1;
						var nextDelta = lastIndex - curRowIndex - 1;
						if(preDelta == 0){
							delete repeateRow.repeatednum;
						}else{
							repeateRow.repeatednum = preDelta;
						}
						repeateRow.copy2Next(nextRow);
						sheetModel.addStyleRow(nextRow);
						if(nextDelta != 0){
							nextRow.repeatednum = nextDelta;
						}else
						{
							delete nextRow.repeatednum;
						}
					}
					repeateRow.copy2Next(rowModel);
					sheetModel.addStyleRow(rowModel);
					delete rowModel.repeatednum;
				}
			}
			if(colIndex){
				this.splitCell(rowModel, rowModel.getCell(colIndex,true));
			}
		},
		splitColumn:function(sheetModel,columnModel,colIndex){
			if(sheetModel == null || sheetModel == undefined || colIndex == null || colIndex == undefined){return;}
			var char2Num = dojo.hitch(websheet.ColumnHelper,"translateFromColCharacters");
			var num2Char = dojo.hitch(websheet.ColumnHelper,"translateFromColNum");
			var repeateColumn = sheetModel.getRepeatedColumn(colIndex);
			if(repeateColumn){
				var curColIndex = char2Num(colIndex);
				var repeatNum = repeateColumn.repeatednum;
				var nextColumn = sheetModel.getColumn( curColIndex + 1,true);
				if(repeateColumn.getIndex() == colIndex){
					if(repeatNum != undefined && repeatNum != 0){
						//if current column is the repeate column,then copy the repeate number to next column
						columnModel.copy2Next(nextColumn);
						delete columnModel.repeatednum;
						if(repeatNum == 1){
							delete nextColumn.repeatednum;
						}else{
							nextColumn.repeatednum -= 1;
						}
						sheetModel.addStyleColumn(nextColumn);
					}
				}else{
					var repeateIndex = char2Num(repeateColumn.getIndex());
					var lastIndex = repeateIndex + repeatNum;
					//if current row is at the end of the repeate range of the repeate row
					if(lastIndex ==  curColIndex){
						if(repeatNum == 1){
							delete repeateColumn.repeatednum;
						}else{
							repeateColumn.repeatednum -= 1;
						}
					}else{
					//if current row is in the middle of the repeate range of the repeate row
						var preDelta = curColIndex - repeateIndex - 1;
						var nextDelta = lastIndex - curColIndex - 1;
						if(preDelta == 0){
							delete repeateColumn.repeatednum;
						}else{
							repeateColumn.repeatednum = preDelta;
						}
						repeateColumn.copy2Next(nextColumn);
						sheetModel.addStyleColumn(nextColumn);
						if(nextDelta != 0){
							nextColumn.repeatednum = nextDelta;
						}
					}
					repeateColumn.copy2Next(columnModel);
					sheetModel.addStyleColumn(columnModel);
					delete columnModel.repeatednum;
				}
			}
		},
		getCellStyle:function(doc,sheetName,rowIndex,colIndex){
			var sheet = doc.getSheet(sheetName);
			var row = sheet.getRepeatedRow(rowIndex);
			if(!row){
				row = sheet.getRow(rowIndex);
			}
			if(row){
				var cell = row.getRepeatedCell(colIndex);
				if(cell){
					return cell.getStyle();					
				}
			}
			return null;			
		},
		
		getColumnStyle: function(doc,sheetName,colIndex)
		{
			var sheet = doc.getSheet(sheetName);
			var colModel = sheet.getRepeatedColumn(colIndex);
			if(null == colModel || undefined == colModel)
			{
				return null;
			}
			else
			{
				return colModel.styleCode;
			}
		}
};
