/****************************************************/
/* created by RuiSuYing, ruisuy@cn.ibm.com          */
/*   6/17/2010                                      */
/* to store style of a spreadsheet document	   		 */
/****************************************************/
dojo.provide("websheet.model.StyleCode");
dojo.declare("websheet.model.StyleCode",null,{
   
	constructor:function(type, SourceStyleCode)
	{
		if (type == "FROMJSON")
		{
			if ( SourceStyleCode == undefined || SourceStyleCode == null )
				return null;
	
			for(var attr in SourceStyleCode)
			{	
				this[attr] = SourceStyleCode[attr];
			}
		}
		else if (type == "FROMOBJ")
		{
			if ( SourceStyleCode == undefined || SourceStyleCode == null )
				return null;
			var strSourceStyleCode = JSON.stringify(SourceStyleCode);
			var newSourceStyleCode = JSON.parse(strSourceStyleCode);
			for(var attr in newSourceStyleCode){ this[attr] = newSourceStyleCode[attr];}
		}
	},	
	
	/**
	 * Author:zhaojp 
	 * CreateTime:2010-08-31 17:56
	 * FunctionName:generateDefault
	 * Version: 01
	 * Function:to generate default cell formatting.
	 * Return parameter:styleChange
	 */
	getDelta:function(oldStyle){
		
        var styleChange={};
        styleChange.font={};
        styleChange.border={};
        styleChange.bordercolor={};

        if((null!=oldStyle.getFormat())&&(""!=oldStyle.getFormat()))
        {
        	styleChange.formatindex="";
        }
        if(""!=oldStyle.getFontname()&&null!=oldStyle.getFontname()&&undefined!=oldStyle.getFontname())
        {
        	styleChange.font.name = "";
        }

        if(""!=oldStyle.getFontsize()&&null!=oldStyle.getFontsize()&&undefined!=oldStyle.getFontsize())
        {
        	styleChange.font.size ="";
        }
        if(""!=oldStyle.getFontcolor()&&null!=oldStyle.getFontcolor()&&undefined!=oldStyle.getFontcolor())
        {
        	styleChange.font.color ="";
        }
        
        if(undefined!=oldStyle.isItalic()&&null!=oldStyle.isItalic()&&false!=oldStyle.isItalic())
        {
        	styleChange.font.italic =false;
        }
        
        if(undefined!=oldStyle.isUnderline()&&false!=oldStyle.isUnderline()&&null!=oldStyle.isUnderline())
        {
        	styleChange.font.underline =false;
        }

        if(undefined!=oldStyle.isStrikethrough()&&false!=oldStyle.isStrikethrough()&&null!=oldStyle.isStrikethrough())
        {
        	styleChange.font.strikethrough =false;
        }
        
        if(undefined!=oldStyle.isBold()&&false!=oldStyle.isBold()&&null!=oldStyle.isBold())
        {
        	styleChange.font.bold =false;
        }
        
        if(""!=oldStyle.getBorderLeft()&&null!=oldStyle.getBorderLeft()&&undefined!=oldStyle.getBorderLeft())
        {
        	styleChange.border.border_left ="";
        }
        
        if(""!=oldStyle.getBorderRight()&&null!=oldStyle.getBorderRight()&&undefined!=oldStyle.getBorderRight())
        {
        	styleChange.border.border_right = "";
        }
        
        if(""!=oldStyle.getBorderTop()&&null!=oldStyle.getBorderTop()&&undefined!=oldStyle.getBorderTop())
        {
        	styleChange.border.border_top = "";
        }
        
        if(""!=oldStyle.getBorderBottom()&&null!=oldStyle.getBorderBottom()&&undefined!=oldStyle.getBorderBottom())
        {
        	styleChange.border.border_bottom = "";
        }  
        if(""!=oldStyle.getBorderLeftColor()&&null!=oldStyle.getBorderLeftColor()&&undefined!=oldStyle.getBorderLeftColor())
        {
        	styleChange.bordercolor.border_left_color ="";
        }  
       
        if(""!=oldStyle.getBorderRightColor()&&
        		null!=oldStyle.getBorderRightColor()&&
        		undefined!=oldStyle.getBorderRightColor())
        {
        	styleChange.bordercolor.border_right_color ="";
        }  
        if(""!=oldStyle.getBorderTopColor()&&
        		null!=oldStyle.getBorderTopColor()&&
        		undefined!=oldStyle.getBorderTopColor())
        {
        	styleChange.bordercolor.border_top_color ="";
        }  
        if(""!=oldStyle.getBorderBottomColor()&&
        		null!=oldStyle.getBorderBottomColor()&&
        		undefined!=oldStyle.getBorderBottomColor())
        {
        	styleChange.bordercolor.border_bottom_color ="";
        }
        
        if(""!=oldStyle.getAlignment()&&
        		null!=oldStyle.getAlignment()&&
        		undefined!=oldStyle.getAlignment())
        {
        	styleChange.text_align ="";
        }
        if(""!=oldStyle.getbgColor()&&
        		null!=oldStyle.getbgColor()&&
        		undefined!=oldStyle.getbgColor())
        {
        	styleChange.background_color="";
        }
        
        if(null!=oldStyle.getIndent()&&
        		""!=oldStyle.getIndent()&&
        		undefined!=oldStyle.getIndent())
        {
        	styleChange.indent="";
        }
        
        if(null!=oldStyle.getAutoWrap()&&
        		false!=oldStyle.getAutoWrap()&&
        		undefined!=oldStyle.getAutoWrap())
        {
        	styleChange.wraptext=false;
        }

        if(styleChange.font.name ==undefined&&
        		styleChange.font.size ==undefined&&
        		styleChange.font.color == undefined&&
        		styleChange.font.bold == undefined&&
        		styleChange.font.italic == undefined&&
        		styleChange.font.underline == undefined&&
        		styleChange.font.strikethrough == undefined)
        {
        	delete styleChange.font;
        }
        
        if(styleChange.border.border_left ==undefined&&
        		styleChange.border.border_top == undefined&&
        		styleChange.border.border_right == undefined&&
        		styleChange.border.border_bottom == undefined)
        {
        	delete styleChange.border;
        }
        

        if(styleChange.bordercolor.border_left_color ==undefined&&
        		styleChange.bordercolor.border_top_color == undefined&&
        		styleChange.bordercolor.border_right_color == undefined&&
        		styleChange.bordercolor.border_bottom_color == undefined)
        {
        	delete styleChange.bordercolor;
        }
        
        return styleChange;
	},
		
	checkDefault: function() {
		return (null == this.getFormat())&&
				(null == this.getFontname())&&
				(null == this.getFontsize())&&
				null == this.getFontcolor()&&
				((null == this.isItalic()) || (false == this.isItalic()))&&
				((null == this.isUnderline()) ||(false ==this.isUnderline()))&&
				((null == this.isStrikethrough())||(false == this.isStrikethrough()))&&
				((null == this.isBold())|| (false == this.isBold()))&&
				null == this.getBorderLeft()&&
				null == this.getBorderRight()&&
				null == this.getBorderTop()&&
				null == this.getBorderBottom()&&
				null == this.getBorderLeftColor()&&
				null == this.getBorderRightColor()&&
				null == this.getBorderTopColor()&&
				null == this.getBorderBottomColor()&&
				null == this.getAlignment()&&
				null == this.getbgColor()&&
				null == this.getIndent()&&
				null == this.getAutoWrap();
	},
		
	compareWithme:function(styleCode2) {
		return (styleCode2.getFormat() == this.getFormat())&&
			(styleCode2.getFontname() == this.getFontname())&&
			(styleCode2.getFontsize() == this.getFontsize())&&
			(styleCode2.getFontcolor() == this.getFontcolor())&&
			(styleCode2.isItalic() == this.isItalic())&&
			(styleCode2.isUnderline() == this.isUnderline())&&
			(styleCode2.isStrikethrough() == this.isStrikethrough())&&
			(styleCode2.isBold() == this.isBold())&&
			(styleCode2.getBorderLeft() == this.getBorderLeft())&&
			(styleCode2.getBorderRight() == this.getBorderRight())&&
			(styleCode2.getBorderTop() == this.getBorderTop())&&
			(styleCode2.getBorderBottom() == this.getBorderBottom())&&
			(styleCode2.getBorderLeftColor() == this.getBorderLeftColor())&&
			(styleCode2.getBorderRightColor() == this.getBorderRightColor())&&
			(styleCode2.getBorderTopColor() == this.getBorderTopColor())&&
			(styleCode2.getBorderBottomColor() == this.getBorderBottomColor())&&
			(styleCode2.getAlignment() == this.getAlignment())&&
			(styleCode2.getbgColor() == this.getbgColor())&&
			(styleCode2.getIndent() == this.getIndent())&&
			(styleCode2.getAutoWrap() == this.getAutoWrap());
	},
	
	/****************************************************************/
	/* when the two style has some items conflict					*/
	/* the first will overlap the second							*/
	/****************************************************************/
	mergeStyle:function( styleCode2 ){
		if ( (""!= this.getFormat()) && !(this.getFormat()) && (styleCode2.getFormat()|| ""==styleCode2.getFormat()) )
			this.setFormat( styleCode2.getFormat());
		
		if ( ("" !=this.getFontname()) && !(this.getFontname()) && (styleCode2.getFontname() || "" == styleCode2.getFontname()))
			this.setFontname(styleCode2.getFontname());
		
		if ( ("" != this.getFontsize()) && !(this.getFontsize()) && (styleCode2.getFontsize() || "" == styleCode2.getFontsize()))
			this.setFontsize(styleCode2.getFontsize());
		
		if ( (""!=this.getFontcolor()) && !(this.getFontcolor()) && (styleCode2.getFontcolor() || "" == styleCode2.getFontcolor()))
			this.setFontcolor(styleCode2.getFontcolor());
		
		if ( (false != this.isItalic()) && !(this.isItalic()) && (styleCode2.isItalic() || false == styleCode2.isItalic()))
			this.setItalic(styleCode2.isItalic());
		
		if ( (false != this.isUnderline()) && !(this.isUnderline()) && (styleCode2.isUnderline() || false == styleCode2.isUnderline()))
			this.setUnderLine(styleCode2.isUnderline());
		
		if ( (false != this.isStrikethrough()) && !(this.isStrikethrough()) && (styleCode2.isStrikethrough() || false == styleCode2.isStrikethrough()))
			this.setStrikethrough(styleCode2.isStrikethrough());
		
		if ( (false != this.isBold()) && !(this.isBold()) && (styleCode2.isBold() || false == styleCode2.isBold() ))
			this.setBold(styleCode2.isBold());
		
		if ( (""!=this.getBorderLeft()) && !(this.getBorderLeft()) && (styleCode2.getBorderLeft() || "" == styleCode2.getBorderLeft()))
			this.setBorderLeft(styleCode2.getBorderLeft());
		
		if ( (""!=this.getBorderRight()) &&!(this.getBorderRight()) && (styleCode2.getBorderRight() || "" == styleCode2.getBorderRight()))
			this.setBorderRight(styleCode2.getBorderRight());
		
		if ( (""!=this.getBorderTop()) && !(this.getBorderTop()) && (styleCode2.getBorderTop() || "" == styleCode2.getBorderTop()))
			this.setBorderTop(styleCode2.getBorderTop());
		
		if ( (""!=this.getBorderBottom())&& !(this.getBorderBottom()) && (styleCode2.getBorderBottom() || "" == styleCode2.getBorderBottom()))
			this.setBorderBottom(styleCode2.getBorderBottom());
		
		if ( (""!=this.getBorderLeftColor())&& !(this.getBorderLeftColor()) && (styleCode2.getBorderLeftColor() || "" == styleCode2.getBorderLeftColor()))
			this.setBorderLeftColor(styleCode2.getBorderLeftColor());
		
		if ( (""!=this.getBorderRightColor())&&!(this.getBorderRightColor()) && (styleCode2.getBorderRightColor() || "" == styleCode2.getBorderRightColor()))
			this.setBorderRightColor(styleCode2.getBorderRightColor());
		
		if ( (""!=this.getBorderTopColor()) && !(this.getBorderTopColor()) && (styleCode2.getBorderTopColor() || "" == styleCode2.getBorderTopColor()))
			this.setBorderTopColor(styleCode2.getBorderTopColor());
		
		if ( (""!=this.getBorderBottomColor()) && !(this.getBorderBottomColor()) && (styleCode2.getBorderBottomColor() || "" == styleCode2.getBorderBottomColor()))
			this.setBorderBottomColor(styleCode2.getBorderBottomColor());
		
		if ( (""!=this.getAlignment() ) && !(this.getAlignment()) && (styleCode2.getAlignment() || "" ==styleCode2.getAlignment()))
			this.setAlignment(styleCode2.getAlignment());
		
		if ( (""!=this.getbgColor()) && !(this.getbgColor()) && (styleCode2.getbgColor() || ""== styleCode2.getbgColor()))
			this.setbgColor(styleCode2.getbgColor());
		
		if ( ("" != this.getIndent()) && !(this.getIndent()) && (styleCode2.getIndent() || "" == styleCode2.getIndent()))
			this.setIndent(styleCode2.getIndent());
		
		if ( (false != this.getAutoWrap())&& !(this.getAutoWrap()) && (styleCode2.getAutoWrap() || false == styleCode2.getAutoWrap()))
			this.setAutoWrap(styleCode2.getAutoWrap());
	},
		
	getFormat:function(){
		if (this.formatindex!=undefined)
		{
			return this.formatindex; 
		}
		return null;
	},
	
	getFontname:function(){
		if (this.font!=undefined)
		{
			if (this.font.name != undefined)
				return this.font.name; 
		}
		return null;
	},
	
	getFontsize:function(){
		if (this.font!=undefined)
		{
			if (this.font.size != undefined)
				return this.font.size; 
		}
		return null;
	},
	
	getFontcolor:function(){
		if (this.font!=undefined)
		{
			if (this.font.color != undefined)
				return this.font.color; 
		}
		return null;
	},
	
	isItalic:function(){
		if (this.font!=undefined)
		{
			if (this.font.italic != undefined)
				return this.font.italic; 
		}
		return null;
	},

	isUnderline:function(){
		if (this.font!=undefined)
		{
			if (this.font.underline != undefined)
				return this.font.underline; 
		}
		return null;
	},
	
	isStrikethrough:function(){
		if (this.font!=undefined)
		{
			if (this.font.strikethrough != undefined)
				return this.font.strikethrough; 
		}
		return null;
	},
	
	isBold:function(){
		if (this.font!=undefined)
		{
			if (this.font.bold != undefined)
				return this.font.bold; 
		}
		return null;
	},
	
	getBorderLeft: function(){
		if (this.border!=undefined)
		{
			if (this.border.border_left != undefined)
				return this.border.border_left; 
		}
		return null;
	},
	
	getBorderRight: function(){
		if (this.border!=undefined)
		{
			if (this.border.border_right != undefined)
				return this.border.border_right; 
		}	
		return null;
	},
	
	getBorderTop: function(){
		if (this.border!=undefined)
		{
			if (this.border.border_top != undefined)
				return this.border.border_top; 
		}
		return null;
	},
	
	getBorderBottom: function(){
		if (this.border!=undefined)
		{
			if (this.border.border_bottom != undefined)
				return this.border.border_bottom; 
		}
		return null;
	},
	
	getBorderLeftColor: function(){
		if (this.bordercolor!=undefined)
		{
			if (this.bordercolor.border_left_color != undefined)
				return this.bordercolor.border_left_color; 
		}
		return null;
	},
	
	getBorderRightColor: function(){
		if (this.bordercolor!=undefined)
		{
			if (this.bordercolor.border_right_color != undefined)
				return this.bordercolor.border_right_color; 
		}
		return null;
	},
	
	getBorderTopColor: function(){
		if (this.bordercolor!=undefined)
		{
			if (this.bordercolor.border_top_color != undefined)
				return this.bordercolor.border_top_color; 
		}
		return null;
	},
	
	getBorderBottomColor: function(){
		if (this.bordercolor!=undefined)
		{
			if (this.bordercolor.border_bottom_color != undefined)
				return this.bordercolor.border_bottom_color; 
		}
		return null;
	},
	
	getAlignment: function(){
		if (this.text_align != undefined )
			return this.text_align;
		return null;
	},
		
	getbgColor: function(){
		if (this.background_color != undefined )
			return this.background_color;
		return null;
	},
	
	getIndent: function(){
		if (this.indent != undefined )
			return this.indent;
		return null;
	},
	
	getAutoWrap: function(){
		if (this.wraptext != undefined )
			return this.wraptext;
		return null;
	},
	
	setFormat:function(formatIndex){
		this.formatindex = formatIndex;
	},
	
	setFontname:function(fontname){
		if (this.font!=undefined)
		{
			this.font.name = fontname; 
		}
		else
		{
			this.font={};
			this.font.name = fontname;
		}
	},
	
	setFontsize:function(fontsize){
		if (this.font!=undefined)
		{
			this.font.size = fontsize;
		}
		else
		{
			this.font = {};
			this.font.size = fontsize;
		}
	},
	
	setFontcolor:function(fontcolor){
		if (this.font!=undefined)
		{
			this.font.color = fontcolor; 
		}
		else
		{
			this.font = {};
			this.font.color = fontcolor;
		}
	},
	
	setItalic:function(isItalic){
		if (this.font!=undefined)
		{
			this.font.italic = isItalic;
		}
		else
		{
			this.font={};
			this.font.italic = isItalic;
		}
	},

	setUnderline:function(isUnderline){
		if (this.font!=undefined)
		{
			this.font.underline = isUnderline; 
		}
		else
		{
			this.font={};
			this.font.underline = isUnderline;
		}
	},
	
	setStrikethrough:function(isStrike){
		if (this.font!=undefined)
		{
			this.font.strikethrough = isStrike; 
		}
		else
		{
			this.font = {};
			this.font.strikethrough = isStrike;
		}
	},
	
	setBold:function(isBold){
		if (this.font!=undefined)
		{
			this.font.bold = isBold;
		}
		else
		{
			this.font = {};
			this.font.bold = isBold;
		}
	},
	
	setBorderLeft: function(borderLeft){
		if (this.border!=undefined)
		{
			this.border.border_left = borderLeft;
		}
		else
		{
			this.border = {};
			this.border.border_left = borderLeft;
		}
	},
	
	setBorderRight: function(borderRight){
		if (this.border!=undefined)
		{
			this.border.border_right = borderRight;
		}	
		else
		{
			this.border = {};
			this.border.border_right = borderRight;
		}
	},
	
	setBorderTop: function(borderTop){
		if (this.border!=undefined)
		{
			this.border.border_top = borderTop;
		}
		else
		{
			this.border.border_top = borderTop;
		}
	},
	
	setBorderBottom: function(borderBottom){
		if (this.border!=undefined)
		{
			this.border.border_bottom = borderBottom;
		}
		else
		{
			this.border = {};
			this.border.border_bottom = borderBottom;
		}
	},
	
	setBorderLeftColor: function(color){
		if (this.bordercolor!=undefined)
		{
			this.bordercolor.border_left_color = color;
		}
		else{
			this.bordercolor = {};
			this.bordercolor.border_left_color = color;
		}
	},
	
	setBorderRightColor: function(color){
		if (this.bordercolor!=undefined)
		{
			this.bordercolor.border_right_color = color;
		}
		else
		{
			this.bordercolor = {};
			this.bordercolor.border_right_color = color;
		}
	},
	
	setBorderTopColor: function(color){
		if (this.bordercolor!=undefined)
		{
			this.bordercolor.border_top_color = color; 
		}
		else
		{
			this.bordercolor = {};
			this.bordercolor.border_top_color = color; 
		}
	},
	
	setBorderBottomColor: function(color){
		if (this.bordercolor!=undefined)
		{
			this.bordercolor.border_bottom_color = color; 
		}
		else
		{
			this.bordercolor = {};
			this.bordercolor.border_bottom_color = color; 
		}
	},
	
	setAlignment: function(alignment){
		this.text_align = alignment;
	},
		
	setbgColor: function(color){
		this.background_color = color;
	},
	
	setIndent: function(indent){
		this.indent = indent;
	},
	
	setAutoWrap: function(wrap){
		this.wraptext = wrap;
	},
	
	
    //zhaojp modify 2010-09-09 
	changeStyle: function(stylechange){
		
		var formatindex=stylechange.formatindex;
		if(null!=formatindex)
		{
			if(""!=formatindex){
				this.formatindex=formatindex;	
			}else{
	       	 	this.formatindex = undefined;
			}
		}
		
		
		var font=stylechange.font;
		if(null!=font&&""!=font)
		{
		    if(null!=font.name)
		    {
		    	if(""!=font.name){
		    		this.setFontname(font.name);
		    	}else{ 
		      		this.font.name = undefined;
		    	}
		    }
		    
		    if(null!=font.size)
		    { 
		    	if(""!=font.size){
		    		this.setFontsize(font.size);	
		    	}else{ 
		      		this.font.size = undefined;
		    	}
		    }
		    if(null!=font.color)
		    { 
		    	if(""!=font.color){
		    	this.setFontcolor(font.color);
		    	}else{ 
		     		 this.font.color = undefined;
		   		}
		    }
		    if(null!=font.italic)
		    { 
		    	if(false!=font.italic){
			    	this.setItalic(font.italic);	
		    	} else{ 
		      		this.font.italic = undefined;
		    	}
		    }
		    if(null!=font.underline)
		    { 
		    	if(false!=font.underline){
		    		this.setUnderline(font.underline)
		    	}else{ 
		      		this.font.underline = undefined;
		    	}
		    }
		    if(null!=font.strikethrough)
		    { 
		    	if(false!=font.strikethrough){
		    		this.setStrikethrough(font.strikethrough);	
		    	}else{ 
		      		this.font.strikethrough = undefined;
		    	}
		    }
		    if(null!=font.bold)
		    { 
		    	if(false!=font.bold){
			    	this.setBold(font.bold);	
		    	} else{ 
		      		 this.font.bold = undefined;
		    	}  
		    }
		    if(undefined==this.font.bold&&undefined==this.font.name&&
		       undefined==this.font.strikethrough&&undefined==this.font.underline&&
		       undefined==this.font.italic&&undefined==this.font.color&&undefined==this.font.size)
		    	this.font = undefined;
		}
		
		var border=stylechange.border;
		if(null!=border&&""!=border)
		{
		    if(null!=border.border_left)
		    {
		    	if(""!=border.border_left){
		    		this.setBorderLeft(border.border_left);
		    	}else { 
		      		this.border.border_left = undefined;
		    	}
		    	
		    }
		    
		    if(null!=border.border_right)
		    {
		    	if(""!=border.border_right){
		    		this.setBorderRight(border.border_right);
		    	}else{ 
		      		this.border.border_right = undefined;
		    	}
		    }
		    if(null!=border.border_top)
		    {
		    	if(""!=border.border_top){
		    		this.setBorderTop(border.border_top);
		    	}else{ 
		      		this.border.border_top = undefined;
		    	}
		    }
		    
		    if(null!=border.border_bottom)
		    {
		    	if(""!=border.border_bottom){
		    		this.setBorderBottom(border.border_bottom);
		    	}else{ 
		      		this.border.border_bottom = undefined;
		    	}
		    }
		     if(undefined==this.border.border_bottom&&undefined==this.border.border_top&&
		       undefined==this.border.border_right&&undefined==this.border.border_left)
				this.border = undefined;
		}
		
		
		var bordercolor=stylechange.bordercolor;
		if(null!=bordercolor&&""!=bordercolor)
		{
		    if(null!=bordercolor.border_left_color)
		    {
		    	if(""!=bordercolor.border_left_color){
		    		this.setBorderLeftColor(bordercolor.border_left_color);
		    	}else{ 
		      		this.bordercolor.border_left_color = undefined;
		    	}
		    	
		    }
		    
		    if(null!=bordercolor.border_right_color)
		    {
		    	if(""!=bordercolor.border_right_color){
		    		this.setBorderRightColor(bordercolor.border_right_color);
		    	}else{ 
		      		this.bordercolor.border_right_color = undefined;
		    	}
		    }
		    
		    if(null!=bordercolor.border_top_color)
		    {
		    	if(""!=bordercolor.border_top_color){
		    		this.setBorderTopColor(bordercolor.border_top_color);
		    	}else{ 
		      		this.bordercolor.border_top_color = undefined;
		    	}
		    	
		    }
		    
		    if(null!=bordercolor.border_bottom_color)
		    {
		    	if(""!=bordercolor.border_bottom_color){
		    		this.setBorderBottomColor(bordercolor.border_bottom_color);
		    	}else{ 
		      		this.bordercolor.border_bottom_color = undefined;
		    	}
		    }
		    if(undefined==this.bordercolor.border_bottom_color&&
		       undefined==this.bordercolor.border_top_color&&
		       undefined==this.bordercolor.border_right_color&&
		       undefined==this.bordercolor.border_left_color)
		 		this.bordercolor = undefined;
		}
		var text_align=stylechange.text_align;
		if(null!=text_align)
		{
			if(""!=text_align){
				this.text_align=text_align;
			}else{
	        	this.text_align = undefined;
			}
		}
		var background_color=stylechange.background_color;
		if(null!=background_color)
		{
			if(""!=background_color){
				this.background_color=background_color;
			}else{   
	        	this.background_color = undefined;
			}
		}
		
		var indent=stylechange.indent;
		if(null!=indent)
		{
			if(""!=indent){
				this.indent=indent;
			}else{
	        	this.indent = undefined;
			}
		}
		
		
		var wraptext=stylechange.wraptext;
		if(null!=wraptext)
		{
			if(""!=wraptext){
				this.wraptext=wraptext;
			}else{
	       		 this.wraptext = undefined;
			}
			
		}
		
		/*
		if (stylechange.formatindex)
			this.setFormat(stylechange.formatindex);
		
		if ((stylechange.font!=undefined)&& stylechange.font.name)
			this.setFontname(stylechange.font.name);
		
		if ((stylechange.font!=undefined)&&stylechange.font.size)
			this.setFontsize(stylechange.font.size);
		
		if ((stylechange.font!=undefined)&&stylechange.font.color)
			this.setFontcolor(stylechange.font.color);
		
		if ((stylechange.font!=undefined)&&stylechange.font.italic!=null)
			this.setItalic(stylechange.font.italic);
		
		if ((stylechange.font!=undefined)&&stylechange.font.underline!=null)
			this.setUnderline(stylechange.font.underline);
		
		if ((stylechange.font!=undefined)&&stylechange.font.strikethrough!=null)
			this.setStrikethrough(stylechange.font.strikethrough);
		
		if ((stylechange.font!=undefined)&&stylechange.font.bold!=null)
			this.setBold(stylechange.font.bold);
		
		if ((stylechange.border!=undefined)&&stylechange.border.border_left)
			this.setBorderLeft(stylechange.border.border_left);
		
		if ((stylechange.border!=undefined)&&stylechange.border.border_right)
			this.setBorderRight(stylechange.border.border_right);
		
		if ((stylechange.border!=undefined)&&stylechange.border.border_top)
			this.setBorderTop(stylechange.border.border_top);
		
		if ((stylechange.border!=undefined)&&stylechange.border.border_bottom)
			this.setBorderBottom(stylechange.border.border_bottom);
		
		if ((stylechange.border!=undefined)&&stylechange.bordercolor.border_left_color)
			this.setBorderLeftColor(stylechange.bordercolor.border_left_color);
		
		if ((stylechange.border!=undefined)&&stylechange.bordercolor.border_right_color)
			this.setBorderRightColor(stylechange.bordercolor.border_right_color);
		
		if ((stylechange.bordercolor!=undefined)&&stylechange.bordercolor.border_top_color)
			this.setBorderTopColor(stylechange.bordercolor.border_top_color);
		
		if ((stylechange.bordercolor!=undefined)&&stylechange.bordercolor.border_bottom_color)
			this.setBorderBottomColor(stylechange.bordercolor.border_bottom_color);
		
		if (stylechange.text_align)
			this.setAlignment(stylechange.text_align);
		
		if (stylechange.background_color)
			this.setbgColor(stylechange.background_color);
		
		if (stylechange.indent)
			this.setIndent(stylechange.indent);
		
		if (stylechange.wraptext)
			this.setAutoWrap(stylechange.wraptext);
	    */
	}
});
