/****************************************************/
/* created by RuiSuYing, ruisuy@cn.ibm.com          */
/*   6/17/2010                                      */
/* to store styles of a spreadsheet document	    */
/****************************************************/
dojo.provide("websheet.model.StyleList");
dojo.require("websheet.model.StyleCode");
 
dojo.declare("websheet.model.StyleList",null,{
	styleList:null,
	
	constructor:function( JSONstyleList ){
		if ( JSONstyleList == undefined || JSONstyleList == null )
			return null;
		
		this.styleList = new Object();
		
		for (var styleID in JSONstyleList)
		{
			if (this.styleList[styleID]!=undefined)
				delete this.styleList[styleID];
			
			this.styleList[styleID] = new Object();
			this.styleList[styleID].stylecode = new websheet.model.StyleCode("FROMJSON", JSONstyleList[styleID]);
			this.styleList[styleID]._refCount = 0;
		}
	},
	
	deleteAll:function(){
		for (var styleID in this.styleList)
		{
			delete this.styleList[styleID];
		}
	},
	
	getJSONObjbyID: function (styleID)
	{
		if (this.styleList[styleID] != undefined)
		{
			var styleBody = JSON.stringify(this.styleList[styleID].stylecode);
			var JSONString = "{\"" + styleID +"\":"+ styleBody + "}";
			return JSON.parse(JSONString);
		}
	},
		
	addStyleCodeReference: function (styleID)
	{	
		this.styleList[styleID]._refCount++;
	},
		
	getStyleCodebyID: function (styleID) {
		if (this.styleList[styleID] != undefined){
			return this.styleList[styleID].stylecode;
		}else{
			return null;
		}
	},
	
	generateStyleCodebyID: function (styleID) {
		if (this.styleList[styleID] != undefined)
		{	
			return new websheet.model.StyleCode("FROMOBJ", this.styleList[styleID].stylecode);
		}else{
			return null;
		}
	},
	
	ChangeStylebyID: function(styleID, styleContent) {
		if (this.styleList[styleID])
		{
			delete this.styleList[styleID];
			this.styleList[styleID] = new Object();
			this.styleList[styleID].stylecode = new websheet.model.StyleCode("FROMJSON", styleContent);
			this.styleList[styleID]._refCount = 0;
			
			return true;
		}
		else
		{
			return false;
		}
	},
			
	changeStyleCodeRefbyID: function (styleID, refCount) {
		if( this.styleList[styleID] )
		{
			this.styleList[styleID]._refCount += refCount;
			if(this.styleList[styleID]._refCount <= 0)
			{
				delete this.styleList[styleID];		
				return false;
			}
		}
		return true;
	},

	/* return value: false -- not exist				*/
	/*				 string	-- the exact style ID	*/
	_checkExist: function (stylecode) {
		for(var styleID in this.styleList){
			if (stylecode.compareWithme(this.styleList[styleID].stylecode))
			{
				if (styleID!=undefined)
				{
					return styleID;
				}
			}
		}
		return false; 
	},
	
	addStyleCodetoList: function (StyleCode) {
		/*if (StyleCode == null)
		{
			return null;
		}
		var oldStyleID = this._checkExist(StyleCode);
		var newStyleID = this.newUUID();
		
		if (oldStyleID != false)
		{
			this.addStyleCodeReference(oldStyleID);
			return oldStyleID;
		}
		else
		{
			this.styleList[newStyleID] = new Object();
			this.styleList[newStyleID]._refCount = 1;
			this.styleList[newStyleID].stylecode = new websheet.model.StyleCode("FROMOBJ", StyleCode);
			
			return newStyleID;
		}*/
		if (StyleCode == null)
		{
			return null;
		}
		var newStyleID = this.newUUID();
		this.styleList[newStyleID] = new Object();
		this.styleList[newStyleID]._refCount = 1;
		this.styleList[newStyleID].stylecode = new websheet.model.StyleCode("FROMOBJ", StyleCode);
		
		return newStyleID;
	},	

	deleteStylefromList:function(styleID) {
		if (this.styleList[styleID])
		{
			delete this.styleList[newStyleID];
			return true;
		}
		else return false;
	},
		
	/* set a new style code to a given style ID				*/
	/* if style ID is null, the function will check whether */
	/* exists or not										*/
	/* if the style ID is not null, the function will update*/
	/* the style or create a new style if the specified ID  */
	/* is used by others									*/
	/* the return value is an object						*/
	/* Bool: indicate whether a new style is created or not	*/
	/* UUID: the style code UUID							*/
	// the _refcount is possibly not correct here.....
	setStyleCode: function (StyleID, StyleCode, refCount) {
		var returnValue = new Object();
		var oldStyleID = _checkExist(StyleCode);
		var newStyleID = newUUID();
		
		// user uses a style from default value
		if (StyleID == null)
		{
			if (oldStyleID != false)
			{
				returnValue.isNew = false;
				returnvalue.styleID = oldStyleID;
				this.styleList[oldStyleID]._refCount += refCount;
			}
			else
			{
				this.styleList[newStyleID]._refCount = 0;
				this.styleList[newStyleID]._refCount += refCount;
				this.styleList[newStyleID].stylecode = new StyleCode("FROMOBJ", StyleCode);
				
				returnValue.isNew = true;
				returnvalue.styleID = newStyleID;
			}
		}
		// user changes a style
		else
		{
			if (oldStyleID == false)
			{	
				this.styleList[newStyleID].stylecode = new StyleCode("FROMOBJ", StyleCode);
				this.styleList[newStyleID]._refCount = 0;
				this.styleList[newStyleID]._refCount += refCount;

				changeStyleCodeRefbyID( StyleID, -1 );
					
				returnValue.isNew = true;
				returnValue.styleID = styleID;

			}
			else if (oldStyleID == StyleID)
			{
				returnValue.isNew = false;
				returnValue.styleID = StyleID;
				
				changeStyleCodeRefbyID( StyleID, refCount );
			}
			else
			{
				returnValue.isNew = false;
				returnValue.style = oldStyleID;
				
				var realref = -refCount;
				changeStyleCodeRefbyID( StyleID, realref );
				changeStyleCodeRefbyID( oldStyleID, refCount );
			}
		}
		return returnValue;
	},	
	
	newUUID:function (){
		var uuid = "";
		for (var i = 1; i <= 32; i++)
		{
			var n = Math.floor(Math.random()*16.0).toString(16);
			uuid += n;
			if((i==8)||(i==12)||(i==16)||(i==20))
					uuid += "_";
		}
		return uuid;
	}

});
