dojo.provide("websheet.event.eventFactory");

websheet.event.eventFactory = {
    //action
	EVENT_ACTION_SET:"set",
	EVENT_ACTION_INSERT:"insert",
	EVENT_ACTION_DELETE:"delete",
	EVENT_ACTION_MOVE:"move",
	EVENT_ACTION_IGNORE:"ignoreme",
	//scope
    EVENT_SCOPE_CELL:"cell",
    EVENT_SCOPE_ROW:"row",
    EVENT_SCOPE_COLUMN:"column",
    EVENT_SCOPE_SHEET:"sheet",
    //range
    EVENT_SCOPE_NAMERANGE:"namerange",
    EVENT_SCOPE_UNNAMERANGE:"unnamerange",
    //cursor
    EVENT_CURSOR:"cursor",
    EVENT_LOCK: 'lock',
    EVENT_RELEASE: 'release',
    
    //data keyword
    KEYWORD_SHEETNAME:"sheetname",
    KEYWORD_SHEETINDEX:"sheetindex",
    KEYWORD_PROPERTY:"property",
    KEYWORD_ROWS:"rows",
    KEYWORD_COLUMNS:"columns",
    KEYWORD_HEIGHT:"height",
    KEYWORD_WIDTH:"width",
    KEYWORD_VALUE:"value",
    KEYWORD_CALCULATEDVALUE:"calculatedvalue",
    KEYWORD_SHOWVALUE:"showvalue",
    KEYWORD_STYLE:"style",
    KEYWORD_STYLE:"styleid",
    KEYWORD_REPEATENUM: "repeatednum",
    
    _mainEventCell:null,
    _eventCell:null,
    // contain all the info used for generate reverse msg
    _reverseEventContent: null,
    
    isOperation:false,	//send message with children
    /* return a event json*/
    setMainEventCell:function(refValue,attrUpdates){
		this._mainEventCell = {};
		this._mainEventCell.refValue = refValue;
		if(attrUpdates){
			this._mainEventCell.attrUpdates = attrUpdates;
		}
	},
	/*
	 * all the info needed for generate reverse event are contained in this._reverseEventContent
	 */
	setReverseEventContent: function(type,attrUpdates)
	{
		if( null == this._reverseEventContent || undefined == this._reverseEventContent )
		{
			this._reverseEventContent = {};
		}
		var tmp = null;
		if(type == "sheet")
		{
			if( undefined == this._reverseEventContent.sheet 
			 || null == this._reverseEventContent.sheet)
			{
				this._reverseEventContent.sheet = {};
			}
			tmp = this._reverseEventContent.sheet;
		}
		else if(type == "row")
		{
			if( undefined == this._reverseEventContent.row 
			 || null == this._reverseEventContent.row)
			{
				this._reverseEventContent.row = {};
			}
			tmp = this._reverseEventContent.row;
		}
		else if(type == "column")
		{
			if( undefined == this._reverseEventContent.column 
			 || null == this._reverseEventContent.column)
			{
				this._reverseEventContent.column = {};
			}
			tmp = this._reverseEventContent.column;
		}
		else if(type == "cell")
		{
			if( undefined == this._reverseEventContent.cell
			 || null == this._reverseEventContent.cell)
			{
				this._reverseEventContent.cell = {};
			}
			tmp = this._reverseEventContent.cell;
		}
		
        for( var attr in attrUpdates)
        {	  
        	tmp[attr] = attrUpdates[attr];
        }
	},
	
    /* return a event json*/
    getEventCell:function(){
		if(this._eventCell == null){this._eventCell = {};}
		return this._eventCell;
	},
	/* add attribute to event json to publish */
	addEventCell:function(refValue,attrUpdates){
		var eCellObj = this.getEventCell();
		//escape the same with the main event
		if(this._mainEventCell && this._mainEventCell.refValue == refValue){
			for(var attr in attrUpdates){
				this._mainEventCell.attrUpdates[attr] = attrUpdates[attr];
			}
			return;
		}
		//if the event list has the refValue,then add the new attribute,or create new one
		if(eCellObj[refValue]){
			for(var attr in attrUpdates){
				eCellObj[refValue][attr] = attrUpdates[attr];
			}
		}else{
			eCellObj[refValue] = attrUpdates;
		}
	},
	
	generateEvent: function(generateEventFunction, generateReverseEventFunction)
	{
	    if(this._mainEventCell == undefined &&
	  	   this._reverseEventContent == undefined 
	  	   && this._reverseEventContent == null)
  	    {
  	    	return null;
  	    }
		var msgObj = {};
        msgObj.translated = true;
        var events = new Array();
        var count = 0;
        events[count] = generateEventFunction(this._mainEventCell.refValue,this._mainEventCell.attrUpdates,true);
        msgObj.events = events;
        if(generateReverseEventFunction){
	    var reversMsg = generateReverseEventFunction();
	    if(LB_COM.autosaveEnable == true && null != reversMsg)
	    {
	      	msgObj.reverse = reversMsg;
	    } 
        }
        return msgObj;
	},
	/*
	 args
	 generateFunction: for the master node
	 generateFunction2: before for the servant node, now for generate revers msg
	*/
	publishEvent:function(publishFunction,generateFunction,generateFunction2)
	{
	    if(this._mainEventCell == undefined &&
	      this._reverseEventContent == undefined && this._reverseEventContent == null)
	    {
	    	return;
	    }
		var msgObj ;
	    if(null == this._mainEventCell) return;
        msgObj = {};
        msgObj.translated = true;
        var events = new Array();
        var count = 0;
        events[count] = generateFunction(this._mainEventCell.refValue,this._mainEventCell.attrUpdates,true);

        msgObj.events = events;

	    if(msgObj != null && msgObj != undefined)
	    {
			publishFunction(msgObj);
		}
	    this.clearEvent();
	},
	
	
	clearEvent:function(){
		for(var attr in this._eventCell){
			delete this._eventCell[attr];
		}
		delete this._mainEventCell;
		delete this._reverseEventContent;
	},
	/** set events*/
	generateSetSheetMsg:function(refValue,attrUpdates,isMainOperate,isReverse){
		if(refValue == null || refValue == undefined || attrUpdates == null || attrUpdates == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_SET,
			reference:{
				refType:this.EVENT_SCOPE_SHEET,
				refValue: refValue
			},
			data:{
				sheet:{
				}
			}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data.sheet[attr] = attrUpdates[attr];
		}

		return message;
	},	
	
    generateSetSheetsMsg:function(refValue,attrUpdates,isMainOperate)
    {
		if(refValue == null || refValue == undefined || attrUpdates == null || attrUpdates == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_SET,
			reference:{
				refType:this.EVENT_SCOPE_SHEET
//				refValue: []
			},
			data:{
				sheets:{
				}
			}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data.sheets[attr] = attrUpdates[attr];
		}
		return message;
	},	
	
	generateSetRowMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined || attrUpdates == null || attrUpdates == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_SET,
			reference:{
				refType:this.EVENT_SCOPE_ROW,
				refValue: refValue
			},
			data:{
				row:{
				}
			}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data.row[attr] = attrUpdates[attr];
		}
		return message;
	},	
	generateSetColumnMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined || attrUpdates == null || attrUpdates == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_SET,
			reference:{
				refType:this.EVENT_SCOPE_COLUMN,
				refValue: refValue
			},
			data:{
				column:{
				}
			}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data.column[attr] = attrUpdates[attr];
		}
		return message;
	},	
	generateSetCellMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined || attrUpdates == null || attrUpdates == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_SET,
			reference:{
				refType:this.EVENT_SCOPE_CELL,
				refValue: refValue
			},
			data:{
				cell:{
				}
			}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data.cell[attr] = attrUpdates[attr];
		}
		return message;
	},
	/** insert events*/
	generateInsertSheetMsg:function(refValue,attrUpdates,isMainOperate, isReverse){
		if(refValue == null || refValue == undefined){return null;}
        
		var message = {
			isoperation:isMainOperate?true:false,
		    action : this.EVENT_ACTION_INSERT,
		    reference:{
				refType:this.EVENT_SCOPE_SHEET,
				refValue: refValue
			},
			data:{
			    sheet: {}
			}
		};
		for(var attr in attrUpdates){
			message.data.sheet[attr] = attrUpdates[attr];
		}
		
//		if(!isReverse){
//			//only for the delete sheet refValue is sheetName|sheetIndex
//			var sheetName = refValue;
//			refValue = sheetName + "|" + attrUpdates["sheetindex"];
//			message.reverse = this.generateDeleteSheetMsg(refValue,null,true,true);
//		}
		return message;
	},	
	
	constructCellObj: function(cellModel)
	{
		var cell = {};
	    var isExist = false;
	    if(cellModel._showValue.length != 0)
	    {
	        cell[this.KEYWORD_SHOWVALUE] = cellModel._showValue;
	        isExist = true;
	    }
	    if(cellModel._rawValue.length != 0)
	    {
	        cell[this.KEYWORD_VALUE] = cellModel._rawValue;
	        isExist = true;
	    }
	    if(cellModel.repeatednum != null)
	    {
	        cell[this.KEYWORD_REPEATENUM] = cellModel.repeatednum;
	        isExist = true;
	    }
	    if(isExist){
	    	return cell;
	    }else{
	    	return null;
	    }    
	},
	
	constructColumnObj: function(columnModel)
	{
	    var col = {};
	    var flag = 0;
	   if(columnModel.width!= null)
	   {
	       col[this.KEYWORD_WIDTH] = columnModel.width;
	       flag++;
	   }
	   if(columnModel.property!= null)
	   {
	       col[this.KEYWORD_PROPERTY] = columnModel.property;
	       flag++;
	   }
	   if(columnModel.repeatednum!= null)
	   {
	       col[this.KEYWORD_REPEATENUM] = columnModel.repeatednum;
	       flag++;
	   }
	   if(flag > 0 ) return col;
	   else return null;
	},
	constructRowObj: function(rowModel)
	{
	   var row = {};
	   var flag = 0;

	   if(rowModel.height!= null)
	   {
	       row[this.KEYWORD_HEIGHT] = rowModel.height;
	       flag++;
	   }
	   if(rowModel.property!= null)
	   {
	       row[this.KEYWORD_PROPERTY] = rowModel.property;
	        flag++;
	   }
	   if(rowModel.repeatednum != null)
	   {
	       row[this.KEYWORD_REPEATENUM] = rowModel.repeatednum;
	        flag++;
	   }
	   if(rowModel.cells!= null)
	   {       
	       var cells = rowModel.cells;
	       var count = this.countObjNum(cells);
	       if(count > 0)
	       {
	           row.cells = {};
	           var existCell = false;
	           for(var cell in cells)
	           {
		           var cellModel = cells[cell];
		           var cellObj = this.constructCellObj(cellModel);
		           if(cellObj){
		        	   row.cells[cell] = cellObj;
		        	   existCell = true;
		           }
	           }
	           flag++;
	           if(!existCell){
	        	   delete row.cells;
	           }
	       }
	   }
	   if(flag > 0) return row;
	   else return null;
	},
	
	constructSheetObj : function(sheetModel)
	{
	   var sheetObj = {};
	   if(sheetModel._name != null)
	   {
	      sheetObj[this.KEYWORD_SHEETNAME] = sheetModel._name;
	   }
	   if(sheetModel.index != null)
	   {
	      sheetObj[this.KEYWORD_SHEETINDEX] = sheetModel.index;
	   }
	   if(sheetModel.property != null)
	   {
	      sheetObj[this.KEYWORD_PROPERTY] = sheetModel.property;
	   }
	   if(sheetModel.rows != null)
	   {
	      var rows = sheetModel.rows;
	      var count = this.countObjNum(rows);
	      if(count > 0)
	      {
	      	  sheetObj.rows={};
	      	  for(var row in rows)
	          {
		          var rowModel = rows[row];
		          var rowObj = this.constructRowObj(rowModel);
		          if(rowObj != null)
		             sheetObj.rows[row] = rowObj;
	          }
	      }
	   }
	   if(sheetModel.columns != null)
	   {
	   	  var columns = sheetModel.columns;
	   	  var count = this.countObjNum(columns);
	   	  if(count > 0)
	   	  {
	   	  	  sheetObj.columns={};
	   	  	  for(var colId in columns)
	          {
		          var colModel = columns[colId];
		          var colObj = this.constructColumnObj(colModel);
		          if(colObj != null)
		             sheetObj.columns[colId] = colObj;
	          }
	   	  }

	   }
	   return sheetObj;
	},
	
	countObjNum : function(Obj)
	{
	    var count = 0;
	    for( var key in Obj)
	    {
	       count++;
	    }
	    return count;
	},
	
	generateInsertRowMsg:function(refValue, attrUpdates,isMainOperate)
	{
		if(refValue == null || refValue == undefined) return null;
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_INSERT,
			reference:{
				refType:this.EVENT_SCOPE_ROW,
				refValue: refValue
			},
			data:{
				row: {}
			}
		};
		return message;
	},	
	
	generateInsertRowWithContentMsg: function(refValue,rowModel,isMainOperate)
	{
		var msg = this.generateInsertRowMsg(refValue,rowModel,isMainOperate);
		var rowJson = rowModel.toEventJson();
		if(null != rowJson)
		{
			msg.data.row = rowJson;
			delete msg.data.row.repeatednum;
		}
		return msg;
	},
	
	generateInsertColumnWithContentMsg: function(refValue, columnModel,isMainOperate)
	{
		var msg = this.generateInsertColumnMsg(refValue, columnModel,isMainOperate);
		var colJson = columnModel.toEventJsonWithCells();
		if(null != colJson)
		{
			msg.data.column = colJson;
			delete msg.data.column.repeatednum;
		}
		var count = 0 ;
		for(var index in msg.data.column.cells)
		{
			count++;
		}
		if(0 == count)
		{
			delete msg.data.column.cells;
		}
		return msg;
	},
	
	generateInsertColumnMsg:function(refValue, columnModel,isMainOperate)
	{
		if(columnModel == null || columnModel == undefined)return null;
		var colObj = this.constructColumnObj(columnModel);
		if(colObj == null) colObj = {};
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_INSERT,
			reference:{
				refType:this.EVENT_SCOPE_COLUMN,
				refValue: refValue
			},
			data:{
				column: colObj
			}
		};
		return message;
	},
	
	/** delete events*/
	generateDeleteSheetMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_DELETE,
			reference:{
				refType:this.EVENT_SCOPE_SHEET,
				refValue: refValue
			}
		}
		return message;
	},	
	generateDeleteRowMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_DELETE,
			reference:{
				refType:this.EVENT_SCOPE_ROW,
				refValue: refValue
			}
		}
		return message;
	},	
	generateDeleteColumnMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_DELETE,
			reference:{
				refType:this.EVENT_SCOPE_COLUMN,
				refValue: refValue
			}
		}
		return message;
	},
	generateDeleteCellMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_DELETE,
			reference:{
				refType:this.EVENT_SCOPE_CELL,
				refValue: refValue
			}
		}
		return message;
	},
	/** move events*/
	generateMoveSheetMsg:function(refValue,attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined){return null;}
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_MOVE,
			reference:{
				refType:this.EVENT_SCOPE_SHEET,
				refValue: refValue
			},
			data:{}
		}
		//attributes update
		for(var attr in attrUpdates){
			message.data[attr] = attrUpdates[attr];
		}
		return message;
	},	
	
	/** reverse msg **/
	//for DeleteSheet, the revers event is insert the deleted sheet
	generateReverseMsg4DeleteSheet: function()
	{
        var events = new Array();
        var count = 0;
        
		var sheetModle = this._reverseEventContent.sheet.model;
		var sheetname = this._reverseEventContent.sheet.sheetname;
		var sheetJson = sheetModle.toEventJson();
		var commentsList = this._reverseEventContent.sheet.commentsList;
		var attrUpdates = {};
		var insertSheetEvent = this.generateInsertSheetMsg(sheetname, attrUpdates, true,true);
		insertSheetEvent.data.sheet = sheetJson;
		
		events[count] = insertSheetEvent;
		count++;

		var cells = this._reverseEventContent.sheet.cells;
		if(undefined != cells && null != cells)
		{
			for(var cellRef in cells)
			{
				var cellObj = cells[cellRef];
				var event = this.generateSetCellMsg(cellRef, attrUpdates, true);
				event.data.cell = cellObj;
				events[count] = event;
				count++;
			}
		}
		if(undefined !=commentsList&& null!= commentsList){
			for(var i in commentsList){
				var id = commentsList[i];
				var refValue = id[0] + "." + id[2] + id[1];
				var attr = {"commentsId":i};
				var setCellEvent = this.generateSetCellMsg(refValue, attr, true);
				events[count] = setCellEvent;
				count++;
			}
		}
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj;
	},
	// for insert sheet, the revers event is delete sheet
	generateReverseMsg4InsertSheet: function()
	{
        var events = new Array();
        var count = 0;
        
		var sheetname = this._reverseEventContent.sheet.sheetname;
		var sheetindex = this._reverseEventContent.sheet.sheetindex;
		var refValue = sheetname + "|" + sheetindex;
		var attrUpdates = {};
		var deleteSheetEvent = this.generateDeleteSheetMsg(refValue, attrUpdates, true);
		events[count] = deleteSheetEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj;
	},
	// for set sheet, the revers event is set to the previous status
	generateReverseMsg4SetSheet: function()
	{
        var events = new Array();
        var count = 0;
        
		var oldSheetname = this._reverseEventContent.sheet.oldSheetname;
		var newSheetname = this._reverseEventContent.sheet.newSheetname;
		var attrUpdates = {};
		attrUpdates.sheetname = oldSheetname;
		var setSheetEvent = this.generateSetSheetMsg(newSheetname, attrUpdates, true, true);
		events[count] = setSheetEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj;
	},
	
	// for move sheet, the reverse event is move to the previous index
	generateReverseMsg4MoveSheet: function()
	{
        var events = new Array();
        var count = 0;
        
		var moveFrom = this._reverseEventContent.sheet.moveFrom;
		var moveTo = this._reverseEventContent.sheet.moveTo;
		var sheetname = this._reverseEventContent.sheet.sheetname;
		var refValue = sheetname + "|" + moveTo;
		var attrUpdates = {};
		attrUpdates.delta = moveFrom - moveTo;
		var moveSheetEvent = this.generateMoveSheetMsg(refValue, attrUpdates, true);
		events[count] = moveSheetEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj; 
	},
	
	//for set cell value, the reverse event is set the cell to previous status
	generateReverseMsg4SetCellValue: function()
	{
        if(undefined == this._reverseEventContent || null == this._reverseEventContent)
        	return null;
		var events = new Array();
        var count = 0;
        
		var refValue = this._reverseEventContent.cell.refValue;
		var oldValue = this._reverseEventContent.cell.value;
		var oldShowValue = this._reverseEventContent.cell.showvalue;
		
		var attrUpdates = {};
		attrUpdates.value = oldValue;
		attrUpdates.showvalue = oldShowValue;
		var setCellEvent = this.generateSetCellMsg(refValue, attrUpdates, true);
		events[count] = setCellEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj; 
	},
	//for set cell commentsId, the reverse event is set the cell to previous status
	generateReverseMsg4CreateComments: function()
	{
        if(undefined == this._reverseEventContent || null == this._reverseEventContent)
        	return null;
		var events = new Array();
        var count = 0;
		var refValue = this._reverseEventContent.cell.refValue;
		var attr = {"commentsId":""};
		var setCellEvent = this.generateSetCellMsg(refValue, attr, true);
		events[count] = setCellEvent;
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj; 
	},
	generateReverseMsg4DelComments:function()
	{
		 if(undefined == this._reverseEventContent || null == this._reverseEventContent)
	        	return null;
			var events = new Array();
	        var count = 0;
			var refValue = this._reverseEventContent.cell.refValue;
			var attr = {"commentsId":this._reverseEventContent.cell.commentsId};
			var setCellEvent = this.generateSetCellMsg(refValue, attr, true);
			events[count] = setCellEvent;
			var msgObj = {};
	        msgObj.translated = true;
	        msgObj.events = events;
	        return msgObj; 
	},
	//for set cell style, the reverse event is set the cell to previous style
	generateReverseMsg4SetCellStyle: function()
	{
		var events = new Array();
        var count = 0;
        
		var refValue = this._reverseEventContent.cell.refValue;
		var oldStyleCode = this._reverseEventContent.cell.styleCode;
		var changeStyle = this._reverseEventContent.cell.styleChange;
		
	    var style = this.getOriginalCellStyle(oldStyleCode,changeStyle);
	    var attrUpdates = {};
	    attrUpdates.style = style;
	    var setCellEvent = this.generateSetCellMsg(refValue,attrUpdates,true);
	    events[count] = setCellEvent;
	    
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj; 
	},
	
	//for every attribute in changeStyle, get the corresponding value in oldStyleCode
	// if does not have, set the value as "";
	getOriginalCellStyle: function(oldStyleCode, changeStyle)
	{
		var style = {};
		var font = {};
		var border = {};
		var bordercolor = {};
		var fontFlag = false;
		var borderFlag = false;
		var bordercolorFlag = false;
		
		var changeStyleCode = new websheet.model.StyleCode("FROMJSON",changeStyle);
		if(changeStyleCode.getFormat() != null)
		{
			var oldValue = oldStyleCode.getFormat();
			style.formatindex = ( oldValue == null) ? "" : oldValue;
		}
		if(changeStyleCode.getAlignment() != null)
		{
			var oldValue = oldStyleCode.getAlignment();
			style.text_align = ( oldValue == null) ? "" : oldValue;
		}
		if(changeStyleCode.getbgColor() != null)
		{
			var oldValue = oldStyleCode.getbgColor();
			style.background_color = ( oldValue == null) ? "" : oldValue;
		}
		if(changeStyleCode.getIndent() != null)
		{
			var oldValue = oldStyleCode.getIndent();
			style.indent = ( oldValue == null) ? "" : oldValue;
		}
		if(changeStyleCode.getAutoWrap() != null)
		{
			var oldValue = oldStyleCode.getAutoWrap();
			style.wraptext = ( oldValue == null) ? false : oldValue;
		}
		if(changeStyleCode.getFontname() != null)
		{
			var oldValue = oldStyleCode.getFontname();
			font.name = ( oldValue == null) ? "" : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.getFontsize() != null)
		{
			var oldValue = oldStyleCode.getFontsize();
			font.size = ( oldValue == null) ? "" : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.getFontcolor() != null)
		{
			var oldValue = oldStyleCode.getFontcolor();
			font.color = ( oldValue == null) ? "" : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.isItalic() != null)
		{
			var oldValue = oldStyleCode.isItalic();
			font.italic = ( oldValue == null) ? false : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.isUnderline() != null)
		{
			var oldValue = oldStyleCode.isUnderline();
			font.underline = ( oldValue == null) ? false : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.isStrikethrough() != null)
		{
			var oldValue = oldStyleCode.isStrikethrough();
			font.strikethrough = ( oldValue == null) ? false : oldValue;
			fontFlag = true;
		}
		if(changeStyleCode.isBold() != null)
		{
			var oldValue = oldStyleCode.isBold();
			font.bold = ( oldValue == null) ? false : oldValue;
			fontFlag = true;
		}
		//border
		if(changeStyleCode.getBorderLeft() != null)
		{
			var oldValue = oldStyleCode.getBorderLeft();
			border.border_left = ( oldValue == null) ? "" : oldValue;
			borderFlag = true;
		}
		if(changeStyleCode.getBorderRight() != null)
		{
			var oldValue = oldStyleCode.getBorderRight();
			border.border_right = ( oldValue == null) ? "" : oldValue;
			borderFlag = true;
		}
		if(changeStyleCode.getBorderTop() != null)
		{
			var oldValue = oldStyleCode.getBorderTop();
			border.border_top = ( oldValue == null) ? "" : oldValue;
			borderFlag = true;
		}
		if(changeStyleCode.getBorderBottom() != null)
		{
			var oldValue = oldStyleCode.getBorderBottom();
			border.border_bottom = ( oldValue == null) ? "" : oldValue;
			borderFlag = true;
		}
		
		//border color
		if(changeStyleCode.getBorderLeftColor() != null)
		{
			var oldValue = oldStyleCode.getBorderLeftColor();
			bordercolor.border_left_color = ( oldValue == null) ? "" : oldValue;
			bordercolorFlag = true;
		}
		if(changeStyleCode.getBorderRightColor() != null)
		{
			var oldValue = oldStyleCode.getBorderRightColor();
			bordercolor.border_right_color = ( oldValue == null) ? "" : oldValue;
			bordercolorFlag = true;
		}	
		if(changeStyleCode.getBorderTopColor() != null)
		{
			var oldValue = oldStyleCode.getBorderTopColor();
			bordercolor.border_top_color = ( oldValue == null) ? "" : oldValue;
			bordercolorFlag = true;
		}
		if(changeStyleCode.getBorderBottomColor() != null)
		{
			var oldValue = oldStyleCode.getBorderBottomColor();
			bordercolor.border_bottom_color = ( oldValue == null) ? "" : oldValue;
			bordercolorFlag = true;
		}
		if(fontFlag == true)
		{
			style.font = font;
		}
		if(borderFlag == true)
		{
			style.border = border;
		}
		if(bordercolorFlag == true)
		{
			style.bordercolor = bordercolor;
		}
		return style;
	},
	//for insert row, the reverse event is delete row
	generateReverseMsg4InsertRow: function()
	{
		var events = new Array();
    var count = 0;
    
		var refValue = this._reverseEventContent.row.refValue;
		var attrUpdates = {};
		var deleteRowEvent = this.generateDeleteRowMsg(refValue,attrUpdates,true);
		events[count] = deleteRowEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj;
		
	},
	//for delete row, the reverse event is insert the deleted row
	generateReverseMsg4DeleteRow: function()
	{
		var events = new Array();
        var count = 0;
    
		var refValue = this._reverseEventContent.row.refValue;
		var rowJson = this._reverseEventContent.row.rowJson;
		var cells = this._reverseEventContent.row.cells;
		var commentsList = this._reverseEventContent.row.commentsList;
		var attrUpdates = {};
		var insertRowEvent = this.generateInsertRowMsg(refValue,attrUpdates,true);
		insertRowEvent.data.row = rowJson;
		
		if(null != cells)
		{
			insertRowEvent.data.row.otherCells = cells;
		}		
		events[count] = insertRowEvent;
		count++;
		
		if(undefined != cells && null != cells)
		{
			for(var cellRef in cells)
			{
				var cellObj = cells[cellRef];
				var event = this.generateSetCellMsg(cellRef, attrUpdates, true);
				event.data.cell = cellObj;
				events[count] = event;
				count++;
			}
		}
		if(undefined !=commentsList&& null!= commentsList){
			for(var i in commentsList){
				var id = commentsList[i];
				var refValue = id[0] + "." + id[2] + id[1];
				var attr = {"commentsId":i};
				var setCellEvent = this.generateSetCellMsg(refValue, attr, true);
				events[count] = setCellEvent;
				count++;
			}
		}
		var msgObj = {};
		msgObj.translated = true;
		msgObj.events = events;
		return msgObj;
	},
	
	//for insert column, the reverse event is delete column
	generateReverseMsg4InsertColumn: function()
	{	
		var events = new Array();
		var count = 0;
    
		var refValue = this._reverseEventContent.column.refValue;
		var attrUpdates = {};
		var deleteColumnEvent = this.generateDeleteColumnMsg(refValue,attrUpdates,true);
		events[count] = deleteColumnEvent;
		
		var msgObj = {};
        msgObj.translated = true;
        msgObj.events = events;
        return msgObj;
	},
	//for delete column, the reverse event is insert the deleted column
	generateReverseMsg4DeleteColumn: function()
	{
		var events = new Array();
		var count = 0;
    
		var refValue = this._reverseEventContent.column.refValue;
		var columnJson = this._reverseEventContent.column.columnJson;
		var cells = this._reverseEventContent.column.cells;
		var commentsList = this._reverseEventContent.column.commentsList;
		var attrUpdates = {};
		var insertColumnEvent = this.generateInsertColumnMsg(refValue,attrUpdates,true);
		insertColumnEvent.data.column = columnJson;
		if(null != cells)
		{
			insertColumnEvent.data.column.otherCells = cells;
		}		
		events[count] = insertColumnEvent;
		count++;
		
		var cells = this._reverseEventContent.column.cells;
		if(undefined != cells && null != cells)
		{
			for(var cellRef in cells)
			{
				var cellObj = cells[cellRef];
				var event = this.generateSetCellMsg(cellRef, attrUpdates, true);
				event.data.cell = cellObj;
				events[count] = event;
				count++;
			}
		}
		if(undefined !=commentsList&& null!= commentsList){
			for(var i in commentsList){
				var id = commentsList[i];
				var refValue = id[0] + "." + id[2] + id[1];
				var attr = {"commentsId":i};
				var setCellEvent = this.generateSetCellMsg(refValue, attr, true);
				events[count] = setCellEvent;
				count++;
			}
		}		
		var msgObj = {};
		msgObj.translated = true;
		msgObj.events = events;
		return msgObj;
	},
	//for set row style
	generateReverseMsg4SetRowStyle: function()
	{
		var events = new Array();
		var count = 0;
		var msgObj = {};
		
		var refValue = this._reverseEventContent.row.refValue;
//		var styleChange = this._reverseEventContent.row.styleChange;
		var cells = this._reverseEventContent.row.cells;
		var attrUpdates = {};
		var setRowEvent = this.generateSetRowMsg(refValue,attrUpdates,true);
		setRowEvent.data.row.isExsit = this._reverseEventContent.row.isExsit;
		
		if(null != cells && undefined != cells)
		{
			setRowEvent.data.row.cells = cells;
		}
		
		events[count] = setRowEvent;
		count++;
		
		msgObj.translated = true;
		msgObj.events = events;
		return msgObj;
	},
    //for set column style
    generateReverseMsg4SetColumnStyle: function()
    {
    	var events = new Array();
		var count = 0;
    
		var refValue = this._reverseEventContent.column.refValue;
		var oldStyleCode = this._reverseEventContent.column.styleCode;
		var styleChange = this._reverseEventContent.column.styleChange;
		var style = this.getOriginalCellStyle(oldStyleCode,styleChange);
		var attrUpdates = {};
		attrUpdates.style = style;
		attrUpdates.selecttype = 2;
		var setColStyleEvent = this.generateSetColumnMsg(refValue,attrUpdates,true);
		events[count] = setColStyleEvent;
		count++;
		
		var cellsStyleCode = this._reverseEventContent.column.styleCellsCode;
		if(null != cellsStyleCode)
		{
			var cells = new Array();
			for(var rowIndex in cellsStyleCode)
			{
				var oldStyle = cellsStyleCode[rowIndex];
				var cellStyle = this.getOriginalCellStyle(oldStyle,styleChange);
				var cell = {};
				cell.rowIndex = rowIndex;
				cell.style = cellStyle;
				cells.push(cell);
//				var updates = {};
//				updates.style = cellStyle;
//				var setCellEvent = this.generateSetCellMsg(cellRef,updates,true);
//				events[count] = setCellEvent;
//				count++;
			}
			if(cells.length > 0)
			{
//				events[0].data.column.otherCells = cells;
				events[0].data.column.cells = cells;
			}
		}

		var msgObj = {};
		msgObj.translated = true;
		msgObj.events = events;
		return msgObj;
    },
    //for set column width
    generateReverseMsg4SetColumnWidth: function()
    {
    	var events = new Array();
		var count = 0;
    
		var refValue = this._reverseEventContent.column.refValue;
		var oldWidth = this._reverseEventContent.column.width;
		var attrUpdates = {};
		attrUpdates.width = oldWidth;
		var setColWidthEvent = this.generateSetColumnMsg(refValue,attrUpdates,true);
		events[count] = setColWidthEvent;
		count++;
		var msgObj = {};
		msgObj.translated = true;
		msgObj.events = events;
		return msgObj;
    },
	generateCursorMsg:function(refValue){
		if(refValue == null || refValue == undefined ){return null;}
		var message = {
			isoperation:false,
			action : this.EVENT_CURSOR,
			reference:{
				refType:this.EVENT_CURSOR,
				refValue: refValue
			}
		}
		return message;
	},
	generateLockMsg:function(refValue){
		if(refValue == null || refValue == undefined ){return null;}
		var message = {
			isoperation:false,
			action : this.EVENT_LOCK,
			reference:{
				refType:this.EVENT_LOCK,
				refValue: refValue
			}
		}
		return message;
	},
	generateReleaseMsg:function(refValue){
		if(refValue == null || refValue == undefined ){return null;}
		var message = {
			isoperation:false,
			action : this.EVENT_RELEASE,
			reference:{
				refType:this.EVENT_RELEASE,
				refValue: refValue
			}
		}
		return message;
	},
	
	/*
	 * generate a new event object, exactly the same as original one
	 */
	copyMsg:function(msg){
		if ((msg == undefined)||(msg == null))
			return null;
		
		var msgJSON = JSON.stringify(msg);
		var newMsg = JSON.parse(msgJSON);
			
		return newMsg;
	},
	
	/*
	 * generate a new event object, with all reverse event been removed
	 */
	copyMsgwithoutReverseEvent:function(msg){
		if ((msg == undefined)||(msg == null))
			return null;
		
		var msgJSON = JSON.stringify(msg);
		var newMsg = JSON.parse(msgJSON);
		
		if (newMsg.reverse!=undefined)
		{
			delete newMsg.reverse;
		}
				
		return newMsg;
	},
	
	/*
	 * generate a new message object, with all the reverse event been moved to event.
	 * if an event doesn't have a reverse event, this event will be removed from events array
	 */
	copyMsgwithReverseasEvent:function(msg){
		if ((msg == undefined)||(msg == null))
			return null;
		
		if ((msg.reverse!=undefined)&&(msg.reverse!=null))
		{	
			var msgJSON = JSON.stringify(msg.reverse);
			var newMsg = JSON.parse(msgJSON);
			
			return newMsg;
		}
		else
			return null;
	},
	
	generateInsertUnnameRangeMsg:function(refValue, attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined) 
			return null;
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_INSERT,
			reference:{
				refType:this.EVENT_SCOPE_UNNAMERANGE,
				refValue:refValue
			},
			data:{
				usage:attrUpdates.usage
			}
		}
		return message;
	},	
	
	generateDeleteUnnameRangeMsg:function(refValue, attrUpdates,isMainOperate){
		if(refValue == null || refValue == undefined) 
			return null;
		var message = {
			isoperation:isMainOperate?true:false,
			action : this.EVENT_ACTION_DELETE,
			reference:{
				refType:this.EVENT_SCOPE_UNNAMERANGE,
				refValue:refValue
			}
		}
		return message;
	}
};
