/*!
 * jQuery Long Tap Plugin.
 */
(function($){
	$.fn.longpress = function(onLongPressCallback,tapCallback,miniDuration){
		var timer;
		var beginX,beginY,endX,endY;
		var isTimeOut=false;
		var isMoved=false;
		miniDuration = miniDuration == null? 500 : miniDuration;

		$(this).bind("touchstart",function(event){
			var e = event.originalEvent;
			if(e.touches.length!=0)
			{
					 
				endX = beginX = e.touches[0].pageX;
				endY=beginY=e.touches[0].pageY;
					 
				timer=setTimeout(
					function(){
						isTimeOut=true;
						if(onLongPressCallback==null || typeof(onLongPressCallback)=="function")
							onLongPressCallback(event);
					}
					,miniDuration);	 
			}
			return true;		 
		});
		$(this).bind("touchmove",function(event){
			var e = event.originalEvent;
			if(e.touches.length!=0)
			{
				endX = e.touches[0].pageX;
				endY = e.touches[0].pageY;
				if(Math.abs(endX-beginX)>3 || Math.abs(endY-beginY)>3)
				{
					clearTimeout(timer);
					isMoved=true;
				}
			}
			return true;
		});
		$(this).bind("touchend",function(event){
			if(!isTimeOut && !isMoved)
			{
				if(tapCallback==null || typeof(tapCallback)=="function")
					 tapCallback(event);
			}
			else
			{
				isTimeOut=false;
				isMoved=false;
			}
					 
			clearTimeout(timer);
			return true;
		});
	};
})(jQuery);