//class for lex parse

var defaultWidth = 300;
var defalutHeight = 150;
var deta;
var bBox;
var oldBox;
var border = 20;
function tokenParser(cmd) {
	this.cmd = cmd;
	this.tokenList = new Array();
	for ( var i = 0; i < cmd.length;) {
		var c = cmd[i];
		if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z')) {
			var action = cmd.substr(i).match(/^[a-zA-Z]+/);
			this.tokenList.push(action);
			i += action.length;
		} else if ((c >= '0' && c <= '9') || c == '-') {
			var numberStr = cmd.substr(i).match(/^-?\d+(\.\d+)?/)[0];
			var number = Number(numberStr);
			if (number != Number.NaN)
				this.tokenList.push(number);
			i += numberStr.length;
		} else {
			i++;
		}
	}
	this.first = function() {
		return this.tokenList[0];
	};
	this.length = function() {
		return this.tokenList.length;
	};
	this.deDueue = function() {
		return this.tokenList.shift();
	};
};
// Point class
function Point(x, y) {
	this.x = x;
	this.y = y;
	this.offset = function(point) {
		this.x += point.x;
		this.y += point.y;
	};
}
//Rect class
function Rect(left, top, right, bottom) {
	this.leftTop = new Point(left, top);
	this.width = right - left;
	this.height = bottom - top;

	this.left = left;
	this.right = right;
	this.top = top;
	this.bottom = bottom;
	this.getLeftTop = function() {
		return this.leftTop;
	};
	this.getLeft = function() {
		return this.leftTop.x;
	};
	this.getTop = function() {
		return this.leftTop.y;
	};
	this.getRight = function() {
		return this.leftTop.x + this.width;
	};
	this.getBottom = function() {
		return this.leftTop.y + this.height;
	};
	this.getWidth = function() {
		return this.width;
	};
	this.getHeight = function() {
		return this.height;
	};

	this.setLeft = function(left) {
		this.left = left;
		this.leftTop.x = left;
		this.width = this.right - left;
	}
	this.setRight = function(right) {
		this.right = right;
		this.width = right - this.left;
	}
	this.setTop = function(top) {
		this.Top = top;
		this.leftTop.y = top;
		this.height = this.bottom - top;
	}
	this.setBottom = function(bottom) {
		this.bottom = bottom;
		this.height = bottom - this.top;
	}
}
//translate the svg:d to the form of  svgPath
function normalizePath(cmd) {
	var tp = new tokenParser(cmd);
	var normalizedPath = "";
	while (tp.length() > 0) {
		var token = tp.deDueue();
		if (typeof (token) == "number") {
			var number = token / 1000 * deta;
			normalizedPath = normalizedPath + number + " ";
		} else if (token == "A" || token == "a") {
			normalizedPath = normalizedPath + token + " ";
			var flag = 1;
			for ( var i = 0; i < 7; ++i) {
				if (typeof (tp[i]) != "number") {
					flag = 0;
				}
			}
			if (flag == 1) {
				for ( var i = 0; i < 5; ++i)
					normalizedPath = normalizedPath + tp.deDueue() + " ";
				// only the last two numbers need transformation
				normalizedPath = normalizedPath + tp.deDueue() / 1000 * deta
						+ " ";
				normalizedPath = normalizedPath + tp.deDueue() / 1000 * deta
						+ " ";
			}
		} else {
			normalizedPath = normalizedPath + token + " ";
		}
	}
	return normalizedPath;
};
// parse point from the tokenParser
function getPointOrg(tp) {
	var number1 = tp.tokenList[0];
	var number2 = tp.tokenList[1];
	if (typeof (number1) == "number" && typeof (number2) == "number") {
		tp.deDueue();
		tp.deDueue();
		return new Point(number1, number2);
	} else {
		return null;
	}
}

//define canvas
function getCanvas($page) {
	//$canvas = $page.children("canvas:first");
	// if( $canvas.length == 0 )//
	var tmp = document.getElementById("$canvas");
	if (tmp == null) {
		//not found, create new
		$canvas = $("<canvas id=\"$canvas\"></canvas>");
		$canvas.appendTo($page);
		$canvas.attr("width", $page.width());
		$canvas.attr("height", $page.height());
		$canvas.css("position", "absolute");
		$canvas.css("left", 0);
		$canvas.css("top", 0);
	}
	return $canvas;

}
//define canvas
function getNewCanvas($page, $isNew) {
	$canvas = $page.children("canvas:first");
	if ($isNew == 1)//
	{
		//not found, create new
		$canvas = $("<canvas id=\"$canvas\"></canvas>");
		$canvas.appendTo($page);
		$canvas.attr("width", $page.width() / 4);
		$canvas.attr("height", $page.height() / 4);
		$canvas.css("position", "absolute");
		$canvas.css("left", 0);
		$canvas.css("top", 0);
	}
	return $canvas;

}
//adjust point coordinate according to the cancas size
function normalizeForShape(point) {
	if (point == null) {
		return new Point(0, 0);
	}
	var normalizedPoint = new Point(0, 0);
	var rect = this.rect;
	if (rect.getWidth() != 0)
		normalizedPoint.x = Math
				.round(point.x * defaultWidth / rect.getWidth());
	else
		normalizedPoint.x = 0;
	if (rect.getHeight() != 0)
		normalizedPoint.y = Math.round(point.y * defalutHeight
				/ rect.getHeight());
	else
		normalizedPoint.y = 0;

	return normalizedPoint;
}

//DrawSVG 
function ShapeSVGPathHelper(ctx, rect, cmd) {
	this.rect = rect;// 
	this.previousPoint = null;

	this.MOperation = MOperation;
	this.LOperation = LOperation;
	this.ZOperation = ZOperation;
	this.NOperation = NOperation;

	this.XOperation = XOperation;
	this.YOperation = YOperation;
	this.UOperation = UOperation;
	this.TOperation = TOperation;
	this.COperation = COperation;
	this.QOperation = QOperation;
	this.AOperation = AOperation;
	this.BOperation = BOperation;
	this.WOperation = WOperation;
	this.VOperation = VOperation;

	this.normalize = normalizeForShape;

	var oldStrokeStyle = ctx.strokeStyle;
	var oldFillStyle = ctx.fillStyle;
	var tp = new tokenParser(cmd);
	
	ifStroke_ifFill(tp, ctx);
	ctx.beginPath();
	while (tp.length() > 0) {
		var token = tp.deDueue();

		if (token == "M") {
			this.MOperation(ctx, tp);
		} else if (token == "L") {
			this.LOperation(ctx, tp);
		} else if (token == "Z") {
			this.ZOperation(ctx, tp);
		} else if (token == "N") {
			this.NOperation(ctx, tp);
			
			//Added by lvying 
			//To recover canvas stroke and fill status
			ctx.strokeStyle = oldStrokeStyle;
			ctx.fillStyle = oldFillStyle;
			//test if "F" or "S" cmd is included
			ifStroke_ifFill(tp, ctx);		
			//begin a new path with the pre fill and stroke
			ctx.beginPath();
			
		} else if (token == "X") {
			this.XOperation(ctx, tp);
		} else if (token == "Y") {
			this.YOperation(ctx, tp);
		} else if (token == "U") {
			this.UOperation(ctx, tp);
		} else if (token == "T") {
			this.TOperation(ctx, tp);
		} else if (token == "C") {
			this.COperation(ctx, tp);
		} else if (token == "Q") {
			this.QOperation(ctx, tp);
		} else if (token == "A") {
			this.AOperation(ctx, tp);
		} else if (token == "B") {
			this.BOperation(ctx, tp);
		} else if (token == "W") {
			this.WOperation(ctx, tp);
		} else if (token == "V") {
			this.VOperation(ctx, tp);
		} else if (token == "S") {
			
		} else if (token == "F") {

		}
	}
	ctx.stroke();
	ctx.fill();
}
function drawShapeSVGPath(ctx, rect, cmd) {

	return new ShapeSVGPathHelper(ctx, rect, cmd);
}
function BoundingBoxHelper($page, rect, cmd) {
	this.rect = rect;// original rect
	this.boundingBox = new Rect(rect.getLeft(), rect.getTop(), rect.getRight(),
			rect.getBottom());

	this.MOperation = MOperationB;// M:simple xy
	this.LOperation = MOperationB;
	this.ZOperation = NOperationB;// N:nothing
	this.NOperation = NOperationB;

	this.XOperation = MOperationB;
	this.YOperation = MOperationB;
	this.UOperation = UOperationB;// U:(x-w,y-h, x+w,y+h)
	this.TOperation = UOperationB;
	this.COperation = COperationB;// C: (x,y)
	this.QOperation = QOperationB;// Q: (x,y)
	this.AOperation = AOperationB;// A: (x1,y1, x2,y2)
	this.BOperation = AOperationB;
	this.WOperation = AOperationB;
	this.VOperation = AOperationB;

	// this.normalize = normalizeForShape;
	this.updateBoundingBox = updateBoundingBox;

	this.maxW = $page.width() * this.rect.getWidth() / defaultWidth;
	this.maxH = $page.height() * this.rect.getHeight() / defalutHeight;

	var tp = new tokenParser(cmd);

	while (tp.length() > 0) {
		var token = tp.deDueue();

		if (token == "M") {
			this.MOperation(tp);
		} else if (token == "L") {
			this.LOperation(tp);
		} else if (token == "Z") {
			this.ZOperation(tp);
		} else if (token == "N") {
			this.NOperation(tp);
		} else if (token == "X") {
			this.XOperation(tp);
		} else if (token == "Y") {
			this.YOperation(tp);
		} else if (token == "U") {
			this.UOperation(tp);
		} else if (token == "T") {
			this.TOperation(tp);
		} else if (token == "C") {
			this.COperation(tp);
		} else if (token == "Q") {
			this.QOperation(tp);
		} else if (token == "A") {
			this.AOperation(tp);
		} else if (token == "B") {
			this.BOperation(tp);
		} else if (token == "W") {
			this.WOperation(tp);
		} else if (token == "V") {
			this.VOperation(tp);
		} else if (token == "S") {

		} else if (token == "F") {

		}
	}

	if (this.boundingBox.getLeft() < 0) {
		this.boundingBox.setLeft(0);
	}
	if (this.boundingBox.getRight() > this.maxW) {
		this.boundingBox.setRight(this.maxW);
	}
	if (this.boundingBox.getBottom() > this.maxH) {
		this.boundingBox.setBottom(this.maxH);
	}
	if (this.boundingBox.getTop() < 0) {
		this.boundingBox.setTop(0);
	}

	bBox = this.boundingBox;
	oldBox = this.rect;
}
function evalBoundingBox($page, rect, cmd) {

	return new BoundingBoxHelper($page, rect, cmd);
}

function SVGPathHelper(path) {
	canto("$canvas").beginPath().svgpath(path).stroke();
}

//DrawConnectorSVG 
function drawConnectorSVGPath(cmd) {
	var path = normalizePath(cmd);
	// canto("$canvas").beginPath().svgpath(path).stroke();
	return new SVGPathHelper(path);
}
//M
function MOperation(ctx, tp) {
	var pointOrg = getPointOrg(tp);
	var point;
	if (pointOrg != null) {
		point = this.normalize(pointOrg);
		ctx.moveTo(point.x, point.y);// ctx

		this.previousPoint = point;

	}
}
//L
function LOperation(ctx, tp) {
	var pointOrg = getPointOrg(tp);
	var point;
	while (pointOrg != null) {
		point = this.normalize(pointOrg);
		ctx.lineTo(point.x, point.y);// ctx
		this.previousPoint = point;
		pointOrg = getPointOrg(tp);
	}
}
//Z
function ZOperation(ctx, tp) {
	//ctx.lineTo(startPoint.x, startPoint.y);
	ctx.closePath();// close Path

}
//N
function NOperation(ctx, tp) {
	/*	if( ! window.nostyle) {
	 ctx.fill();
	 ctx.stroke();
	
	 window.nostyle = false;
	 }
	 */

	ctx.fill();
	ctx.stroke();

}
//X
function XOperation(ctx, tp) {
	var pointOrg = getPointOrg(tp);
	var point;
	var xyFlipFlag = 1;
	while (pointOrg != null) {
		point = this.normalize(pointOrg);
		var kappa = .5522848;
		var yFlag = (point.y - this.previousPoint.y) > 0 ? 1 : -1;
		var xFlag = (point.x - this.previousPoint.x) > 0 ? 1 : -1;
		var h = Math.abs(point.y - this.previousPoint.y) * 2;
		var w = Math.abs(point.x - this.previousPoint.x) * 2;

		ox = (w / 2) * kappa; // control point offset horizontal
		oy = (h / 2) * kappa; // control point offset vertical

		var cp1 = new Point(0, 0);
		var cp2 = new Point(0, 0);

		if (xyFlipFlag) {//normal X
			xyFlipFlag = 0;
			cp2.x = point.x;
			cp2.y = point.y - yFlag * oy;

			cp1.y = this.previousPoint.y;
			cp1.x = this.previousPoint.x + xFlag * ox;
		} else {//flip to Y
			xyFlipFlag = 1;
			cp2.y = point.y;
			cp2.x = point.x - xFlag * ox;

			cp1.x = this.previousPoint.x;
			cp1.y = this.previousPoint.y + yFlag * oy;
		}

		ctx.bezierCurveTo(cp1.x, cp1.y, cp2.x, cp2.y, point.x, point.y);

		this.previousPoint = point;
		pointOrg = getPointOrg(tp);
	}
}
//Y
function YOperation(ctx, tp) {
	var pointOrg = getPointOrg(tp);
	var point;
	var xyFlipFlag = 1;
	while (pointOrg != null) {
		point = this.normalize(pointOrg);

		var kappa = .5522848;
		var yFlag = (point.y - this.previousPoint.y) > 0 ? 1 : -1;
		var xFlag = (point.x - this.previousPoint.x) > 0 ? 1 : -1;
		var h = Math.abs(point.y - this.previousPoint.y) * 2;
		var w = Math.abs(point.x - this.previousPoint.x) * 2;

		ox = (w / 2) * kappa; // control point offset horizontal
		oy = (h / 2) * kappa; // control point offset vertical

		var cp1 = new Point(0, 0);
		var cp2 = new Point(0, 0);

		if (xyFlipFlag) {//normal y
			xyFlipFlag = 0;
			cp2.y = point.y;
			cp2.x = point.x - xFlag * ox;

			cp1.x = this.previousPoint.x;
			cp1.y = this.previousPoint.y + yFlag * oy;
		} else {//flip to x
			xyFlipFlag = 1;
			cp2.x = point.x;
			cp2.y = point.y - yFlag * oy;

			cp1.y = this.previousPoint.y;
			cp1.x = this.previousPoint.x + xFlag * ox;
		}

		ctx.bezierCurveTo(cp1.x, cp1.y, cp2.x, cp2.y, point.x, point.y);

		this.previousPoint = point;
		pointOrg = getPointOrg(tp);
	}
}
//U
function UOperation(ctx, tp) {
	var cpointOrg = getPointOrg(tp);
	var whOrg = getPointOrg(tp);
	var bea = getPointOrg(tp);

	while (cpointOrg != null) {
		cpoint = this.normalize(cpointOrg);
		wh = this.normalize(whOrg);

		//wh.x = wh.x * 2; // redzhong thinks w, h in odf is wrong
		//wh.y = wh.y * 2;
		
		//w,h is correct if it is 21600/2
		//so it is no need to double as above

		var rx = wh.x / 2, ry = wh.y / 2, cx = cpoint.x, cy = cpoint.y;

		var sa = bea.x * Math.PI / 180;
		var ea = bea.y * Math.PI / 180;

		// compute the start and end points
		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		ctx.moveTo(sx, sy);

		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, true);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));//
		cpointOrg = getPointOrg(tp);
		whOrg = getPointOrg(tp);
		bea = getPointOrg(tp);
	}
}
//T
function TOperation(ctx, tp) {
	var cpointOrg = getPointOrg(tp);
	var whOrg = getPointOrg(tp);
	var bea = getPointOrg(tp);
	while (cpointOrg != null) {
		cpoint = this.normalize(cpointOrg);
		wh = this.normalize(whOrg);

		wh.x = wh.x * 2; // redzhong thinks w, h in odf is wrong
		wh.y = wh.y * 2;

		var rx = wh.x / 2, ry = wh.y / 2, cx = cpoint.x, cy = cpoint.y;

		var sa = bea.x * Math.PI / 180;
		var ea = bea.y * Math.PI / 180;

		// compute the start and end points
		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		// ctx.moveTo(sx,sy);
		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, true);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));// ????
		cpointOrg = getPointOrg(tp);
		whOrg = getPointOrg(tp);
		bea = getPointOrg(tp);
	}
}
//C
function COperation(ctx, tp) {
	var cp1Org = getPointOrg(tp);
	var cp2Org = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (cp1Org != null) {
		cp1 = this.normalize(cp1Org);
		cp2 = this.normalize(cp2Org);
		ep = this.normalize(epOrg);

		ctx.bezierCurveTo(cp1.x, cp1.y, cp2.x, cp2.y, ep.x, ep.y);
		this.previousPoint = (ep);//
		cp1Org = getPointOrg(tp);
		cp2Org = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
//C
function QOperation(ctx, tp) {
	var cp1Org = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (cp1Org != null) {
		cp1 = this.normalize(cp1Org);
		ep = this.normalize(epOrg);

		ctx.quadraticCurveTo(cp1.x, cp1.y, ep.x, ep.y);
		this.previousPoint = (ep);//
		cp1Org = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
//A
function AOperation(ctx, tp) {
	var boxPoint1Org = getPointOrg(tp);
	var boxPoint2Org = getPointOrg(tp);
	var spOrg = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (boxPoint1Org != null) {
		boxPoint1 = this.normalize(boxPoint1Org);
		boxPoint2 = this.normalize(boxPoint2Org);
		sp = this.normalize(spOrg);
		ep = this.normalize(epOrg);

		var rx = (boxPoint2.x - boxPoint1.x) / 2, ry = (boxPoint2.y - boxPoint1.y) / 2, cx = (boxPoint2.x + boxPoint1.x) / 2, cy = (boxPoint2.y + boxPoint1.y) / 2;

		var sa = atanHelper(cx, cy, sp.x, sp.y);
		var ea = atanHelper(cx, cy, ep.x, ep.y);

		// compute the start and end points

		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		ctx.lineTo(sx, sy);

		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, true);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));// ????
		boxPoint1Org = getPointOrg(tp);
		boxPoint2Org = getPointOrg(tp);
		spOrg = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
//B
function BOperation(ctx, tp) {
	var boxPoint1Org = getPointOrg(tp);
	var boxPoint2Org = getPointOrg(tp);
	var spOrg = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (boxPoint1Org != null) {
		boxPoint1 = this.normalize(boxPoint1Org);
		boxPoint2 = this.normalize(boxPoint2Org);
		sp = this.normalize(spOrg);
		ep = this.normalize(epOrg);

		var rx = Math.abs(boxPoint2.x - boxPoint1.x) / 2, ry = Math
				.abs(boxPoint2.y - boxPoint1.y) / 2, cx = (boxPoint2.x + boxPoint1.x) / 2, cy = (boxPoint2.y + boxPoint1.y) / 2;

		var sa = atanHelper(cx, cy, sp.x, sp.y);
		var ea = atanHelper(cx, cy, ep.x, ep.y);

		// compute the start and end points
		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		ctx.moveTo(sx, sy);

		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, true);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));// ????
		boxPoint1Org = getPointOrg(tp);
		boxPoint2Org = getPointOrg(tp);
		spOrg = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
//W
function WOperation(ctx, tp) {
	var boxPoint1Org = getPointOrg(tp);
	var boxPoint2Org = getPointOrg(tp);
	var spOrg = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (boxPoint1Org != null) {
		boxPoint1 = this.normalize(boxPoint1Org);
		boxPoint2 = this.normalize(boxPoint2Org);
		sp = this.normalize(spOrg);
		ep = this.normalize(epOrg);

		var rx = (boxPoint2.x - boxPoint1.x) / 2, ry = (boxPoint2.y - boxPoint1.y) / 2, cx = (boxPoint2.x + boxPoint1.x) / 2, cy = (boxPoint2.y + boxPoint1.y) / 2;

		var sa = atanHelper(cx, cy, sp.x, sp.y);
		var ea = atanHelper(cx, cy, ep.x, ep.y);

		// compute the start and end points
		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		ctx.lineTo(sx, sy);

		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, false);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));// ????
		boxPoint1Org = getPointOrg(tp);
		boxPoint2Org = getPointOrg(tp);
		spOrg = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
//V
function VOperation(ctx, tp) {
	var boxPoint1Org = getPointOrg(tp);
	var boxPoint2Org = getPointOrg(tp);
	var spOrg = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (boxPoint1Org != null) {
		boxPoint1 = this.normalize(boxPoint1Org);
		boxPoint2 = this.normalize(boxPoint2Org);
		sp = this.normalize(spOrg);
		ep = this.normalize(epOrg);

		var rx = (boxPoint2.x - boxPoint1.x) / 2, ry = (boxPoint2.y - boxPoint1.y) / 2, cx = (boxPoint2.x + boxPoint1.x) / 2, cy = (boxPoint2.y + boxPoint1.y) / 2;

		var sa = atanHelper(cx, cy, sp.x, sp.y);
		var ea = atanHelper(cx, cy, ep.x, ep.y);

		// compute the start and end points
		var sx = cx + rx * Math.cos(sa), sy = cy + ry * Math.sin(sa);
		var ex = cx + rx * Math.cos(ea), ey = cy + ry * Math.sin(ea);

		ctx.moveTo(sx, sy);

		ctx.translate(cx, cy);
		ctx.scale(rx / ry, 1);
		ctx.arc(0, 0, ry, sa, ea, false);
		ctx.scale(ry / rx, 1);
		ctx.translate(-cx, -cy);

		this.previousPoint = (new Point(ex, ey));// ????

		boxPoint1Org = getPointOrg(tp);
		boxPoint2Org = getPointOrg(tp);
		spOrg = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}
function atanHelper(x1, y1, x2, y2) {
	var dy = y2 - y1;
	var dx = x2 - x1;
	var angle = Math.atan(dy / dx);

	if (dx < 0) {//2,3 quadrant
		angle = (angle + Math.PI);
	} else if (dy < 0) {//4 quadrant
		angle = (angle + 2 * Math.PI);
	}
	//angle = 2* Math.PI - angle;// clock wise
	return angle;

}
function setWH(width, height) {
	defaultWidth = width;
	defalutHeight = height;
}

//method for evaluating bounding box
function updateBoundingBox(point) {
	if (point != null) {
		if (point.x > this.boundingBox.getRight()) {
			this.boundingBox.setRight(point.x);
		}
		if (point.x < this.boundingBox.getLeft()) {
			this.boundingBox.setLeft(point.x);
		}
		if (point.y > this.boundingBox.getBottom()) {
			this.boundingBox.setBottom(point.y);
		}
		if (point.y < this.boundingBox.getTop()) {
			this.boundingBox.setTop(point.y);
		}

	}
}

//MB
function MOperationB(tp) {
	var pointOrg = getPointOrg(tp);
	while (pointOrg != null) {
		this.updateBoundingBox(pointOrg);// orginal point
		pointOrg = getPointOrg(tp);
	}
}

//NB
function NOperationB(tp) {

}

//UB
function UOperationB(tp) {
	var cpointOrg = getPointOrg(tp);
	var whOrg = getPointOrg(tp);
	var bea = getPointOrg(tp);
	while (cpointOrg != null) {
		this.updateBoundingBox(new Point(cpointOrg.x + whOrg.x, cpointOrg.y
				+ whOrg.y));// orginal point
		this.updateBoundingBox(new Point(cpointOrg.x - whOrg.x, cpointOrg.y
				- whOrg.y));// orginal point

		pointOrg = getPointOrg(tp);

		cpointOrg = getPointOrg(tp);
		whOrg = getPointOrg(tp);
		bea = getPointOrg(tp);
	}
}

//CB
function COperationB(tp) {
	var cp1Org = getPointOrg(tp);
	var cp2Org = getPointOrg(tp);
	var epOrg = getPointOrg(tp);

	while (cp1Org != null) {
		this.updateBoundingBox(cp1Org);// orginal point
		this.updateBoundingBox(cp2Org);
		this.updateBoundingBox(epOrg);
		cp1Org = getPointOrg(tp);
		cp2Org = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}

//QB
function QOperationB(tp) {
	var cp1Org = getPointOrg(tp);
	var epOrg = getPointOrg(tp);
	while (cp1Org != null) {
		this.updateBoundingBox(cp1Org);// orginal point
		this.updateBoundingBox(epOrg);// orginal point
		cp1Org = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}

//AB
function AOperationB(tp) {
	var boxPoint1Org = getPointOrg(tp);
	var boxPoint2Org = getPointOrg(tp);
	var spOrg = getPointOrg(tp);
	var epOrg = getPointOrg(tp);

	while (boxPoint1Org != null) {
		this.updateBoundingBox(boxPoint2Org);// orginal point
		boxPoint1Org = getPointOrg(tp);
		boxPoint2Org = getPointOrg(tp);
		spOrg = getPointOrg(tp);
		epOrg = getPointOrg(tp);
	}
}

function getBoundingBoxW() { //return in pix
	var w = bBox.getRight() - bBox.getLeft();
	return w * defaultWidth / oldBox.getWidth() + border * 2;
}

function getBoundingBoxH() { //return in pix
	var h = bBox.getBottom() - bBox.getTop();
	return h * defalutHeight / oldBox.getHeight() + border * 2;

}

//adjust draw:points to svg:d
function normalizeDrawPoints(cmd, newX, newY) {
	var tp = new tokenParser(cmd);
	var normalizedPath = "";
	var index = 1;
	var x = newX;
	var y = newY;
	while (tp.length() > 0) {
		var token = tp.deDueue();
		if (typeof (token) == "number") {
			if (index % 2 != 0) {
				var number = (token + x) / 1000 * deta;
				normalizedPath = normalizedPath + number + " ";
				index++;
			} else {
				var number = (token + y) / 1000 * deta;
				normalizedPath = normalizedPath + number + " ";
				index++;
			}
		} else {
			normalizedPath = normalizedPath + token + " ";
		}
	}
	return normalizedPath;
}

//Added by lvying 
//To test whether the cmd of "S" and "F" 
//is included in SVG path 
function ifStroke_ifFill(tp, ctx) {
	
	var index=0;	
	while(index < (tp.length() -1) )
	{
		if(tp.tokenList[index] == "S")
		{
			ctx.strokeStyle = "transparent";//noStroke is true;
		}
		else if(tp.tokenList[index] == "F")
		{
			ctx.fillStyle = "transparent";//nofill is true;	
		}
		else if(tp.tokenList[index] == "N")
		{
			break;
		}
		index++;
	}

}


function beginDrawArrow(x1,y1,x2,y2,lineWidth){
	//Main idea for the arrow drawing:
	//A(x1,y1) is control point
	//B(x2,y2) is where arrow starts
	//AB vector is the direction of the arrow
	//calculate out three points stand for the arrow, then line and fill 
	var lenX = x2 - x1;
	var lenY = y2 - y1;
	var len = Math.sqrt( lenX*lenX + lenY*lenY );

	if(lineWidth > deta * 0.15){
		lineWidth *= 0.7;
	}
	else 
		lineWidth = 0.08 * deta;
	
	var arrowWidthX = lineWidth * 4 * lenX / len;
	var arrowWidthY = lineWidth * 4 * lenY / len;


	//the end of the arrow
	var Xbottom = x2 - arrowWidthX;
	var Ybottom = y2 - arrowWidthY; 

	var degree = 0;
	if (y1 == y2) {
		if (x2 > x1)
			degree = 1.5708;
		else if ( x1 > x2)
			degree = -1.5708;
	} else {
		var degreeValue =  (x2-x1)/(y2-y1);
		degree = Math.atan( degreeValue );		
	}
	var X = Math.cos(degree) * 2.2 * lineWidth;
	var Y = Math.sin(degree) * 2.2 * lineWidth;
	//discuss different situation of the arrow direction
	
		var Xleft = x2 + X - arrowWidthX;
		var Yleft = y2 - Y - arrowWidthY;
		var Xright = x2 - X - arrowWidthX;
		var Yright = y2 + Y - arrowWidthY;
	

	//orgnize the path
	path = "M" + (x2 + arrowWidthX * 0.5) + " "+ (y2 + arrowWidthY * 0.5);
	path = path + " " + Xleft +" " +Yleft +" "+ Xbottom + " "+ Ybottom +" " +Xright +" " +Yright ;  
	path = path + " "+(x2 + arrowWidthX * 0.5) + " "+ (y2 + arrowWidthY * 0.5) ;

	canto("$canvas").beginPath().svgpath(path).fill();
}


function DrawArrowAction(cmd,startWithArrow,endWithArrow,connectorOrLine,lineWidth){
	//eight indexs 
	var START_X = 0;
	var START_Y = 1;
	var END_X = 2;
	var END_Y = 3;
	var END_CTL_X = 4;
	var END_CTL_Y = 5;
	var START_CTL_X = 6;
	var START_CTL_Y = 7;
	var arrowCoordArray = null;
	var character = 'p';

	var path;
	//line path,with the flag 'l', has no need to be normalized.
	if(connectorOrLine=='c')
		path = normalizePath(cmd);
	else path = cmd;
	if(startWithArrow || endWithArrow){
		arrowCoordArray = new Array(8);
		for(var j=0;j<8;j++)
			arrowCoordArray[j] = null;
	}else 
		return arrowCoordArray;//null

	var i=0;
	//Traverse the path and get four points in coordinates
	while(i < path.length){	
		switch(path[i]){
			case 's':
			case 'S':
			// smooth bezier curve
			i = i + 2;// get the start index of number-string
			var tempStr_X = "";
			var tempStr_Y = "";
			while (path[i] != ' ') {
				tempStr_X = tempStr_X + path[i++];
			}
			i++;// get the start index of number-string
			while (path[i] != ' ') {
				tempStr_Y = tempStr_Y + path[i++];
			}
			i++;

			var end_ctrl_x = Number(tempStr_X);
			var end_ctrl_y = Number(tempStr_Y);

			if (character != 'c' && character != 's') {
				arrowCoordArray[START_CTL_X] = end_ctrl_x;
				arrowCoordArray[START_CTL_Y] = end_ctrl_y;
			} else {
				arrowCoordArray[START_CTL_X] = 2 * arrowCoordArray[END_X]
						- arrowCoordArray[END_CTL_X];
				arrowCoordArray[START_CTL_Y] = 2 * arrowCoordArray[END_Y]
						- arrowCoordArray[END_CTL_Y];
			}
			arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X] + end_ctrl_x;
			arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y] + end_ctrl_y;

			// get the end point
			tempStr_X = tempStr_Y = "";
			while (path[i] != ' ') {
				tempStr_X = tempStr_X + path[i++];
			}
			i++;// get the start index of number-string
			while (path[i] != ' ') {
				tempStr_Y = tempStr_Y + path[i++];
			}
			i++;// get the start index of next cmd
			// get the end point
			arrowCoordArray[END_X] += Number(tempStr_X);
			arrowCoordArray[END_Y] += Number(tempStr_Y);

			character = 's';
			break;
			// deal with the case of curve
			case 'c':
			case 'C':
				i=i+2;// get the start index of number-string
				var tempStr_X = "";
				var tempStr_Y = "";
				while(path[i]!=' '){
					tempStr_X = tempStr_X + path[i++];
				}
				i++;// get the start index of number-string
				while(path[i]!=' '){
					tempStr_Y = tempStr_Y + path[i++];
				}
				i++;// get the start index of number-string
				// get the start control point
				if(arrowCoordArray[START_CTL_X] == null)
				{
					arrowCoordArray[START_CTL_X] = arrowCoordArray[START_X] + Number(tempStr_X);
					arrowCoordArray[START_CTL_Y] = arrowCoordArray[START_Y] + Number(tempStr_Y);
				}

				tempStr_X = tempStr_Y = "";
				while(path[i]!=' '){
					tempStr_X = tempStr_X + path[i++];
				}
				i++;//get the start index of number-string
				while(path[i]!=' '){
					tempStr_Y = tempStr_Y + path[i++];
				}
				i++;//get the start index of number-string
				//get the end control point (offset to the start point)
				arrowCoordArray[END_CTL_X] = arrowCoordArray[START_X] + Number(tempStr_X);
				arrowCoordArray[END_CTL_Y] = arrowCoordArray[START_Y] + Number(tempStr_Y);
				
				tempStr_X = tempStr_Y = "";
				while(path[i]!=' '){
					tempStr_X = tempStr_X + path[i++];
				}
				i++;//get the start index of number-string
				while(path[i]!=' '){
					tempStr_Y = tempStr_Y + path[i++];
				}
				i++;//get the start index of next cmd
				//get the end point
				arrowCoordArray[END_X] += Number(tempStr_X);
				arrowCoordArray[END_Y] += Number(tempStr_Y);
				character = 'c';
				break;
			//deal with the case of vertical cmd
			case 'v':
			case 'V':
				i=i+2;//get the start index of number-string
				var tempStr = "";
				while(path[i]!=' ')
					tempStr = tempStr + path[i++];
				//tempStr == 0 mean no movement
				if(Number(tempStr)==0){
					i++;
					character = 'v';
					break;
				}
				//move the end point forward 
				//and make the former end point as end control point
				arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y];
				arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X];
				arrowCoordArray[END_Y] += Number(tempStr);
				if(arrowCoordArray[START_CTL_X] == null)
				{
					arrowCoordArray[START_CTL_X] = arrowCoordArray[START_X];
					arrowCoordArray[START_CTL_Y] = arrowCoordArray[END_Y];
				}
				i++;//get the start index of next cmd
				character = 'v';
				break;
			//deal with the case of horizonal cmd
			case 'h':
			case 'H':
				i=i+2;//get the start index of number-string
				var tempStr = "";
				while(path[i]!=' ')
					tempStr = tempStr + path[i++];
				//tempStr == 0 mean no movement
				if(Number(tempStr)==0){
					i++;
					character = 'h';
					break;
				}
				arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X];
				arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y];
				arrowCoordArray[END_X] += Number(tempStr);
				//get the start control point
				if(arrowCoordArray[START_CTL_X] == null)
				{
					arrowCoordArray[START_CTL_X] = arrowCoordArray[END_X];
					arrowCoordArray[START_CTL_Y] = arrowCoordArray[START_Y];
				}
				//get the start index of next cmd
				i++;
				character = 'h';
				break;
			
			case 'l':
			case 'L':					
			//deal with the case of move cmd
			case 'm':
			case 'M':
				//get the start index of number-string
				i=i+2;
				var tempStr = "";
				while(path[i] != ' ')
					tempStr = tempStr + path[i++];
				if(character == 'p'){
					arrowCoordArray[START_X] = Number(tempStr);
					arrowCoordArray[END_X] = arrowCoordArray[START_X];					
				}
				else {
					arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X];
					arrowCoordArray[END_X] += Number(tempStr);
				}
				//get the start index of number-string
				i++;
				tempStr = "";
				while(path[i] != ' ')
					tempStr = tempStr + path[i++];
				if(character == 'p'){
					arrowCoordArray[START_Y] = Number(tempStr);
					arrowCoordArray[END_Y] = arrowCoordArray[START_Y];	
				}
				else {
					arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y];
					arrowCoordArray[END_Y] += Number(tempStr);
				}
				character = 'm';
				//get the start index of next cmd
				i++;
				break;

			default:
				//todo: the case of two curve
				if(character == 'c'){
					var tempStr_X = "";
					var tempStr_Y = "";
					while(path[i]!=' '){
						path[i++];
					}
					i++;
					while(path[i]!=' '){
						path[i++];
					}
					i++;

					while(path[i]!=' '){
						tempStr_X = tempStr_X + path[i++];
					}
					//get the start index of number-string
					i++;
					while(path[i]!=' '){
						tempStr_Y = tempStr_Y + path[i++];
					}
					//get the start index of number-string
					i++;
					//get the end control point (offset to the start point)
					arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X] + Number(tempStr_X);
					arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y] + Number(tempStr_Y);
					
					tempStr_X = tempStr_Y = "";
					while(path[i]!=' '){
						tempStr_X = tempStr_X + path[i++];
					}
					i++;//get the start index of number-string
					while(path[i]!=' '){
						tempStr_Y = tempStr_Y + path[i++];
					}
					//get the start index of next cmd
					i++;
					//get the end point
					arrowCoordArray[END_X] += Number(tempStr_X);
					arrowCoordArray[END_Y] += Number(tempStr_Y);
				}
				else if(character == 'm'){
					var tempStr_X = "";
					var tempStr_Y = "";
					while(path[i]!=' '){
						tempStr_X = tempStr_X + path[i++];
					}
					i++;
					while(path[i]!=' '){
						tempStr_Y = tempStr_Y + path[i++];
					}
					i++;
					if(arrowCoordArray[START_CTL_X] == null)
					{
						arrowCoordArray[START_CTL_X] = arrowCoordArray[START_X] + Number(tempStr_X);
						arrowCoordArray[START_CTL_Y] = arrowCoordArray[START_Y] + Number(tempStr_Y);
					}
					arrowCoordArray[END_CTL_X] = arrowCoordArray[END_X];
					arrowCoordArray[END_X] += Number(tempStr_X);
					arrowCoordArray[END_CTL_Y] = arrowCoordArray[END_Y];
					arrowCoordArray[END_Y] += Number(tempStr_Y);
				} else {
					// unknown command, abort drawing
					return;
				}
				break;
		}//switch
	}//while

	if(arrowCoordArray!=null){
		if(startWithArrow)
			beginDrawArrow(arrowCoordArray[START_CTL_X],arrowCoordArray[START_CTL_Y],arrowCoordArray[START_X],arrowCoordArray[START_Y],lineWidth);
		if(endWithArrow)
			beginDrawArrow(arrowCoordArray[END_CTL_X],arrowCoordArray[END_CTL_Y],arrowCoordArray[END_X],arrowCoordArray[END_Y],lineWidth);
	}
}