dojo.provide("websheet.parse.token");
dojo.require("websheet.parse.tokenType");
dojo.declare("websheet.parse.token", null, {
	_token: "",										//token text
	_tokenType: 0,									//token type
	_calcuteValue:null,								//the token calculative value	
	_parent:null,									//token's parent if it has
	
	constructor: function(args) {
		dojo.mixin(this, args);
	},
	
	/**
	 *
	 * @param {String} paramCols
	 */
	setToken:function(paramToken){
		this._token = paramToken;
	},
	getToken:function(){
		return this._token;
	},
	
	setCalcuteValue:function(calcuteValue){
		this._calcuteValue = calcuteValue;
	},
	getCalcuteValue:function(){
		return this._calcuteValue;
	},
	/**
	 *
	 * @param {String} paramCols
	 */
	setTokenType:function(paramTokenType){
		this._tokenType = paramTokenType;
	},
	getTokenType:function(){
		return this._tokenType;
	},
	
	getParent:function(){
		return this._parent;
	},
	
	setParent:function(parent){
		this._parent = parent;
	},
	/**
	 * isShowValue : whether to show value in cell,or show in html nodes
	 * deleteType  : row delete or column delete.0:row delete 1:column delete
	 */			  
	serialize2String:function(isShowValue,deleteType){
		var cells;
		var token;
		var oriCell;
		var isError = false;
		if(this.getTokenType() == websheet.parse.tokenType.CELLREF_TOKEN){
			cells = this.getCalcuteValue().getCells();
			oriCell = cells[0].cell;
			var cell = cells[0].getCellVieType();
			token = "";
			if(cells[0].hasSheetRef){
				if(cell.getParent().getParent().isDelete){
					token = "#REF!" + "." ;
					isError = true;
				}else{
					token = cell.getSheetName() + "." ;
				}
			}
			if(oriCell.getColumn().isDelete && !isError){
				token += "#REF!";
				isError = true;
			}else{
				token += cell.getCol();
			}
			if(oriCell.getParent().isDelete && !isError){
				token += "#REF!";
				isError = true;
			}else{
				token += cell.getRow();
			}
			if(isError){
				oriCell.clearReference();
			}
			this._token = token;
		}else if(this.getTokenType() == websheet.parse.tokenType.RANGEREF_TOKEN){
			var existCells = new Array();
			var oriCells = this.getCalcuteValue().getCells();
			var token = "";
			//delete all cells in deleted column or deleted row
			dojo.forEach(this.getCalcuteValue().getCells(),function(item,index){
				if(item){
					if(item.cell.getParent().isDelete || item.cell.getColumn().isDelete || item.cell.getParent().getParent().isDelete){
						item.cell.clearReference();
					}else{
						this.push(item);
					}
				}
			},existCells);
			//regenerate the cell address
			cells = existCells.sort();
			if(cells.length == 0){
				//the first cell
				var startCell = oriCells[0].getCellVieType();
				//the last cell
				var endCell = oriCells[oriCells.length-1].getCellVieType();
				if(oriCells[0].hasSheetRef && deleteType != 2){
					token = startCell.getSheetName() + "." ;
				}
				if(deleteType == 0){
					//delete row
					token += startCell.getCol() + "#REF!" + ":" + endCell.getCol() + "#REF!";
				}else if(deleteType == 1){
					//delete column
					token += "#REF!" + startCell.getRow() + ":" + "#REF!" + endCell.getRow();
				}else{
					//delete sheet
					token += "#REF!." + startCell.getCol() + startCell.getRow() + ":" + endCell.getCol() + endCell.getRow();
				}
				isError = true;
			}else{
				//the first cell
				var startCell = cells[0].getCellVieType();
				//the last cell
				var endCell = cells[cells.length-1].getCellVieType();
				token = "";
				if(cells[0].hasSheetRef && deleteType != 2){
					token = startCell.getSheetName() + "." ;
				}
				token += startCell.getCol() + startCell.getRow() + ":" + endCell.getCol() + endCell.getRow();
			}
			this.getCalcuteValue().cells = cells;
			this._token = token;
		}
		return {"token" : this._token , "isError":isError};
	}
});
