dojo.provide("websheet.parse.tokenList");
dojo.require("websheet.parse.token");
//dojo.require("websheet.functions.Complete");
dojo.require("websheet.ColumnHelper");
dojo.require("websheet.parse.tokenType");
dojo.declare("websheet.parse.tokenList", null, {
	cell:null,
	tokenList:null,							//its children
	_name: "",								//it maybe have the name.It can be function,or operator,or array
	_parent:null,							//its parent
	_type:0,								//its type
	_calcuteValue:"",						//the result of its token-list to calculate
	isError:false,
	/**
	 * construct
	 */
	constructor:function(args){
		dojo.mixin(this, args);
	},
		
	getName:function(){
		return this._name;
	},
	
	setName:function(name){
		this._name = name;
	},
	
	getTokenType:function(){
		return this._type;
	},
	
	setTokenType:function(type){
		this._type = type;
	},
	
	getParent:function(){
		return this._parent;
	},
	
	setParent:function(parent){
		this._parent = parent;
	},
	
	setTokenList:function(tokenList){
		this.tokenList = tokenList;
	},
	
	getTokenList:function(){
		if(!this.tokenList){
			this.tokenList = new Array();
		}
		return this.tokenList;
	},
	
	setCalcuteValue:function(calcuteValue){
		this._calcuteValue = calcuteValue;
	},
	
	getCalcuteValue:function(){
		return this._calcuteValue;
	},
	
	push:function(token){
		this.getTokenList().push(token);
	},
	/**
	 * add reference cell to the token list of cell
	 * @param {string}tokenValue	token value
	 * @param {int}tokenType		token type
	 */
	addReferencedCell:function(tokenValue,tokenType){
		var relativePos;
		if(tokenType == websheet.parse.tokenType.CELLREF_TOKEN && this.cell){
			relativePos = websheet.ColumnHelper.parse2RelativePosition(this.cell.getRow(),this.cell.getColumn(),tokenValue.getToken());
			this.cell.getRelativeList().push(relativePos);
		}else if(tokenType == websheet.parse.tokenType.RANGEREF_TOKEN && this.cell){
			var refs = tokenValue.getToken().split(":");
			relativePos = websheet.ColumnHelper.parse2RelativePosition(this.cell.getRow(),this.cell.getColumn(),refs[0]);
			relativePos += ":" + websheet.ColumnHelper.parse2RelativePosition(this.cell.getRow(),this.cell.getColumn(),refs[1]);
			this.cell.getRelativeList().push(relativePos);
		}
		this.cell.pushReferenceList(tokenValue);
	},
	/**
	 * show the token tree to UI.
	 */
	serialize2String:function(isShowValue,deleteType){
		if(isShowValue){
			var formula = "";
			var isArrayFormular = false;
			if(this.getTokenType() == websheet.parse.tokenType.FUNCTION_TOKEN){
				formula = this.getName() + "(" + dojo.hitch(this,"recursiveList")(this.getTokenList(),true,deleteType); 
				if(formula.charAt(formula.length - 1) == ";"){
					formula = formula.substring(0, formula.length - 1);
				}
				formula += ")";
			}else if(this.getTokenType() == websheet.parse.tokenType.OPERATOR_TOKEN){
				formula =dojo.hitch(this,"recursiveList")(this.getTokenList()[0],true,deleteType) + this.getName() + dojo.hitch(this,"recursiveList")(this.getTokenList()[1],true,deleteType);
			}else if(this.getTokenType() == websheet.parse.tokenType.ARRAYFORMULA_TOKEN){
				formula =dojo.hitch(this,"recursiveList")(this.getTokenList()[0],true,deleteType);
				isArrayFormular = true;
			}else{
				formula =dojo.hitch(this,"recursiveList")(this.getTokenList(),true,deleteType);
			}
			return {"rawValue":formula,"isError":this.isError,"isArrayFormular":isArrayFormular};
		}else{
			var tableNode = dojo.doc.createElement("table");
			var trNode = dojo.doc.createElement("tr");
			trNode.innerHTML = this.getName() + " value:" + this.getCalcuteValue();
			trNode.appendChild(dojo.hitch(this,"recursiveListToNode")(this.getTokenList(),true,1));
			tableNode.appendChild(trNode);
			return tableNode;
		}
	},
	/**
	 * recursive the token tree
	 * @param {object}tokenList		token tree
	 * @param {Boolean}hasSemiColon as the parameters individually by semicolon
	 * @param {Int}count			the node hierarchy of token tree 
	 * @return {Node|String}		token serialize or html node
	 */
	recursiveList:function(tokenList,hasSemiColon,deleteType){
		//indent with blank
		var formula = "";
		var tempList = tokenList;
		if(!dojo.isArray(tokenList)){
			tempList = new Array();
			tempList.push(tokenList);
		}
		dojo.forEach(tempList,function(item){
			if(dojo.isArray(item)){
				//Arrayݹ鴦һ
				formula += "{" + dojo.hitch(this,"recursiveList")(item,true,deleteType);
				//β";"ȥ
				if(formula.charAt(formula.length - 1) == ";"){
					formula = formula.substring(0, formula.length - 1);
				}
				formula += "};";
			}else if(item instanceof websheet.parse.tokenList){
				//
				if(item.getTokenType() == websheet.parse.tokenType.FUNCTION_TOKEN){
					formula += item.getName() + "(" + dojo.hitch(this,"recursiveList")(item.getTokenList(),true,deleteType); 
					if(formula.charAt(formula.length - 1) == ";"){
						formula = formula.substring(0, formula.length - 1);
					}
					formula += ");";
					//
				}else if(item.getTokenType() == websheet.parse.tokenType.OPERATOR_TOKEN){
					formula +=dojo.hitch(this,"recursiveList")(item.getTokenList()[0],false,deleteType) + item.getName() + dojo.hitch(this,"recursiveList")(item.getTokenList()[1],false,deleteType) + ";";
				}else if(item.getTokenType() == websheet.parse.tokenType.BRACKET_TOKEN){
					//
					formula += "(" + dojo.hitch(this,"recursiveList")(item.getTokenList(),true,deleteType);
					if(formula.charAt(formula.length - 1) == ";"){
						formula = formula.substring(0, formula.length - 1);
					}
					formula += ");";
					//
				}else if(item.getTokenType() == websheet.parse.tokenType.NEGATIVE_TOKEN){
					formula += "-" + dojo.hitch(this,"recursiveList")(item.getTokenList(),false,deleteType) + ";";
				}else{
					formula +=dojo.hitch(this,"recursiveList")(item.getTokenList(),false,deleteType);
				}
			}else if(item instanceof websheet.parse.token){
					var result = item.serialize2String(1,deleteType);
					if(item.getTokenType() == websheet.parse.tokenType.STRING_TOKEN){
						formula += "\"" + result.token + "\"";
					}else{
						formula += result.token;
					}
					if(result.isError){
						this.isError = true;
					}
					formula += ";";
			}
		},this);
		if(formula.charAt(formula.length - 1) == ";"){
			formula = formula.substring(0, formula.length - 1);
		}
		return formula;
	},
	/**
	 * recursive the token tree
	 * @param {object}tokenList		token tree
	 * @param {Boolean}hasSemiColon as the parameters individually by semicolon
	 * @param {Int}count			the node hierarchy of token tree 
	 * @return {Node|String}		token serialize or html node
	 */
	recursiveListToNode:function(tokenList,hasSemiColon,count){
		var tableNode = dojo.doc.createElement("table");
		//indent with blank
		var ampersand = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		var ampCount = count;
		while(ampCount > 1){
			ampersand += ampersand;
			ampCount--;
		}
		var trNode;
		var tdNode;
		var formula = "";
		var tempList = tokenList;
		if(tokenList instanceof websheet.parse.tokenList){
			tempList = tokenList.getTokenList();
		}	
		dojo.forEach(tempList,function(item){
			if(dojo.isArray(item)){
				trNode = dojo.doc.createElement("tr");
				trNode.innerHTML = "{";
				trNode.appendChild(dojo.hitch(this,"recursiveListToNode")(item,true,count+1));
				var trNode2 = dojo.doc.createElement("tr");
				trNode2.innerHTML = "}";
				tableNode.appendChild(trNode);
				tableNode.appendChild(trNode2);
				
				formula += "{" + dojo.hitch(this,"recursiveListToNode")(item,true,count+1);
				if(formula.charAt(formula.length - 1) == ";"){
					formula = formula.substring(0, formula.length - 1);
				}
				formula += "};";
				trNode = null;
				trNode2 = null;
			}else if(item instanceof websheet.parse.tokenList){
				trNode = dojo.doc.createElement("tr");
				trNode.innerHTML = ampersand + item.getName() + " value:" + item.getCalcuteValue();
				trNode.appendChild(dojo.hitch(this,"recursiveListToNode")(item.getTokenList(),true,count+1));
				tableNode.appendChild(trNode);
				
				formula += item.getName() + "(" + dojo.hitch(this,"recursiveListToNode")(item.getTokenList(),true,count+1); 
				if(formula.charAt(formula.length - 1) == ";"){
					formula = formula.substring(0, formula.length - 1);
				}
				formula += ")";
				
				trNode = null;
				
			}else if(item instanceof websheet.parse.token){
				var isCreate = false;
				if(trNode == null || trNode == undefined){
					trNode = dojo.doc.createElement("tr");
					isCreate = true;
				}
				tdNode = dojo.doc.createElement("td");
				var value = item.getToken();
				if(value.trim() == ""){
					value = "blank text";
				}
				tdNode.innerHTML = ampersand + value + " value:" + item.getCalcuteValue();
				trNode.appendChild(tdNode);
				tableNode.appendChild(trNode);
				
				formula += item.getToken();
				if(hasSemiColon){
					formula += ";";
				}
				if(isCreate){
					trNode = null;
				}
			}
			formula += ";";
		},this);
		if(formula.charAt(formula.length - 1) == ";"){
			formula = formula.substring(0, formula.length - 1);
		}
		//return formula;
		return tableNode;
	}
});
